package oldApps;

import java.applet.Applet;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import phyApps.common.ControlPanel;
import phyApps.common.ControlPanelListener;

@SuppressWarnings("serial")
public class SampleInputArea extends Applet implements ActionListener, ControlPanelListener {
	
	ControlPanel panel;
	
	public void init() {
		panel = new ControlPanel();
		
		panel.addScrollbar("scrollbar", "Radius", 0, 0, 10, .03);
		panel.addListener("scrollbar", this);
		panel.addTextField("ypos", "y-Position", 0);
		panel.addTextField("xpos", "x-Position", 0);
		panel.addTextField("xvel", "x-Velocity", 0);
		panel.addTextField("yvel", "y-Velocity", 0);
		panel.addButton("run", "Run", this);
		panel.addButton("pause", "Pause", this);
		panel.addText("Press a button:");
		add(panel);
	}

	public void actionPerformed(ActionEvent event) {
		if (event.getActionCommand().equals("run")) {
			panel.setValue("yvel", 10);
			System.out.println(panel.getValue("xvel"));
		}
		
		else if (event.getActionCommand().equals("pause")) {
			panel.setValue("yvel", 20);
		}
	}

	public void valueChanged(String field, double value) {
		System.out.println(value);
	}
}
