package phyApps.common;

//A uniform discrete probability distribution, implemented using Math.random()
public class Distribution {
	
	protected int min, max, inc;
	
	public Distribution(int min, int max) {
		this(min, max, 1);
	}
	
	public Distribution(int min, int max, int inc) {
		this.min = min;
		this.max = max;
		this.inc = inc;
	}
	
	/**
	 * Choose a random value from the distribution.
	 */
	public int pick() {
		return min + inc*((int) (((max - min)/inc + 1)*Math.random()));
	}
}