package phyApps.common.graph;

import java.awt.Graphics;
import java.awt.Image;

public class ImagePlot extends LocationPlot {

	protected Image image;
	
	public ImagePlot(Graph graph, Image image) {
		super(graph, null);
		this.image = image;
	}
	
	public void switchImage(Image newImage) {
		this.image = newImage;
	}

	@Override
	public void draw(Graphics g) {
		if (location != null && image != null)
			graph.drawImage(g, image, location);
	}
	
}
