package phyApps.common.mvc;

abstract public class Model {

	private View view;
	private Controller controller;
	
	public final void setup(View view, Controller controller) {
		this.view = view;
		this.controller = controller;
	}
	
	protected final void draw() {
		view.draw(this);
		controller.update();
	}
}
