package phyApps.common.mvc;

import java.awt.Component;
import java.awt.Panel;

@SuppressWarnings("serial")
public abstract class View extends Panel {
	
	/**
	 * The model may call this when it has changed, so that the changes can be reflected in the view.
	 */
	abstract public void draw(Model model);
	
	/**
	 * Get the view's panel. This will be the panel shown on the screen.
	 */
	abstract public Component getComponent();
}

