/*
 * Created by JFormDesigner on Wed Jan 06 21:15:42 EST 2010
 */

package WebBuilder;

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.sql.SQLException;

import javax.swing.*;

import com.jgoodies.forms.factories.*;
import com.jgoodies.forms.layout.*;

/**
 * @author Someone
 */
public class LabDocumentframe extends JFrame {
	int labdoc_id ;
	int lab_id;
	String labdoc_type;
	File LabDocFile;
	WebpageDB webDB = null;
	
//"CREATE TABLE lab_document( ID INTEGER IDENTITY, lab_id INTEGER, title VARCHAR(256), doc_type VARCHAR(5), external_URL VARCHAR(256), document_id INTEGER)");
//"CREATE TABLE document( ID INTEGER IDENTITY, title VARCHAR(256), filename VARCHAR(256), document_group VARCHAR(256), user_doc BOOLEAN)");	
	public LabDocumentframe(WebpageDB db, int id, int L_id) {
		webDB = db;
		labdoc_id = id;
		lab_id = L_id;
		//doc_type can be FILE or URL
		initComponents();
		
		if( labdoc_id!=-1) {
			//modify the element
			try {
				String DocType = webDB.query_single("select doc_type from lab_document where ID = " + labdoc_id).toString();
				//Integer SpecElementID = Integer.valueOf(webDB.query_single("select elementID from page_element where ID = " + labdoc_id).toString());
				if (DocType.equals("URL")) {
					//title
					//external_URL
					String title = webDB.query_single("select title from lab_document where ID = " + labdoc_id).toString();
					String external_URL = webDB.query_single("select external_URL from lab_document where ID = " + labdoc_id).toString();
					
					URLTitleField.setText(title);
					URLField.setText(external_URL);
					LabDocTabbedPane.setEnabledAt(0, false);
					LabDocTabbedPane.setSelectedIndex(1);
				} else {
					String title = webDB.query_single("select title from lab_document where ID = " + labdoc_id).toString();
					Integer SpecDocID = Integer.valueOf(webDB.query_single("select document_id from lab_document where ID = " + labdoc_id).toString());
					String filelocation = webDB.query_single("select filename from document where ID = " + SpecDocID).toString();
					
					FileTitleField.setText(title);
					FileLocationField.setText(filelocation);
					LabDocTabbedPane.setEnabledAt(1, false);
					LabDocTabbedPane.setSelectedIndex(0);
					FileBrowseButton.setEnabled(false);
				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}			
		}
	}

	private void FileBrowseButtonActionPerformed(ActionEvent e) {
        final JFileChooser fc = new JFileChooser();
        fc.setCurrentDirectory(new File("./"));
        
        fc.showOpenDialog(this);

        // Get the selected file
        File selFile = fc.getSelectedFile();
        //System.out.print(selFile);
        if (selFile!=null){
        	LabDocFile = selFile;
        	FileLocationField.setText(selFile.getAbsolutePath());
        }
	}

	private void SaveButtonActionPerformed(ActionEvent e) {
		Boolean success= false;
		// TODO add your code here
		if (labdoc_id==-1) {
        	Integer max_page_order;
        	
			//do insert
			Integer labdoc_type = LabDocTabbedPane.getSelectedIndex();
	        switch (labdoc_type) {
	            case 0:  
	            	//file
	    			//check that a title is entered
	    			if (!FileTitleField.getText().isEmpty()) {
		    			if (LabDocFile!=null) {
			            	System.out.println("0 insert file lab doc\n");
			            	
							System.out.print("./" + webDB.DB_NAME + "/" + LabDocFile.getName());
							File testFile = new File("./" + webDB.DB_NAME + "/" + LabDocFile.getName());
							if (!testFile.exists()) {
								//copy it to the webdb directory
								try {
									FileInputStream fis = new FileInputStream(LabDocFile);
								    FileOutputStream fos = new FileOutputStream(new File("./" + webDB.DB_NAME + "/" + LabDocFile.getName()));
								    try {
								        byte[] buf = new byte[1024];
								        int i = 0;
								        while ((i = fis.read(buf)) != -1) {
								            fos.write(buf, 0, i);
								        }
								    } 
								    catch (Exception e1) {
								        throw e1;
								    }
								    finally {
								        if (fis != null) fis.close();
								        if (fos != null) fos.close();
								    }
								} catch (Exception e2) {
									// TODO Auto-generated catch block
									e2.printStackTrace();
								}
				    			try {
		//"CREATE TABLE lab_document( ID INTEGER IDENTITY, lab_id INTEGER, title VARCHAR(256), doc_type VARCHAR(5), external_URL VARCHAR(256), document_id INTEGER)");
		//"CREATE TABLE document( ID INTEGER IDENTITY, title VARCHAR(256), filename VARCHAR(256), document_group VARCHAR(256), user_doc BOOLEAN)");
				    				webDB.update("INSERT INTO document(title, filename, document_group, user_doc) VALUES('" + FileTitleField.getText() + "', '" + LabDocFile.getName() + "','applet',false)");
				    				Integer doc_id = Integer.valueOf(webDB.query_single("select max(ID) from document").toString());
				    				
				    				webDB.update("INSERT INTO lab_document(lab_id,title,doc_type, document_id) VALUES('" + lab_id + "', '" + FileTitleField.getText() + "','FILE'," + doc_id + ")");
				    				success = true;
				    			} catch (SQLException e1) {
				    				// TODO Auto-generated catch block
				    				e1.printStackTrace();
				    			}
							} else {
								Interface.ShowMessgaeBox("there is already a file of that name in the database, please rename the file and try again");
							}
		    			} else {
		    				Interface.ShowMessgaeBox("select a file to proceed");
		    			}	
	    			} else {
	    				Interface.ShowMessgaeBox("enter a title  to proceed");
	    			}				            	
	            	
	            	break;
		        case 1:  
		        	//URL
	    			//check that a title is entered
		        	if (!URLTitleField.getText().isEmpty()) {
			        	if (!URLField.getText().isEmpty()) {
			        		System.out.println("1"); 
		    				try {
								webDB.update("INSERT INTO lab_document(lab_id,title,doc_type, external_URL) VALUES(" + lab_id + ", '" + URLTitleField.getText() + "','URL', '"+ URLField.getText() +"')");
							} catch (SQLException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
			        		success = true;
		    			} else {
		    				Interface.ShowMessgaeBox("enter a URL  to proceed");
		    			}	
	    			} else {
	    				Interface.ShowMessgaeBox("enter a title  to proceed");
	    			}		
	            	break;
	            default: System.out.println("Invalid.");break;
	        }

			
			
		} else {
			//do update of page element
			Integer elem_type = LabDocTabbedPane.getSelectedIndex();
	        switch (elem_type) {
	            case 0:  
	            	//FILE
	            	
	            	//here we should check stuff
	            	
	            	System.out.println("0 update html element\n"); 
	    			try {
	    				Integer SpecDocID = Integer.valueOf(webDB.query_single("select document_id from lab_document where ID = " + labdoc_id).toString());
						webDB.update("UPDATE docuemtn SET title = '" + FileTitleField.getText() + "' where ID = " + SpecDocID);
	    				webDB.update("UPDATE lab_document SET title = '" + URLTitleField.getText() + "' where ID = " + labdoc_id);
						success = true;
	    			} catch (SQLException e1) {
	    				// TODO Auto-generated catch block
	    				e1.printStackTrace();
	    			}
	            	break;
		        case 1:  
		        	//URL
	            	System.out.println("1"); 
				try {
					webDB.update("UPDATE lab_document SET title = '" + URLTitleField.getText() + "' where ID = " + labdoc_id);
					success = true;
				} catch (SQLException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
	            break;

	            default: System.out.println("Invalid.");break;
	        }			
		}
		
		if (success) {
			this.setVisible(false);
			this.dispose();
		}
	}

	private void cancelButtonActionPerformed(ActionEvent e) {
		this.setVisible(false);
		this.dispose();
	}

	private void initComponents() {
		// JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents
		dialogPane = new JPanel();
		contentPanel = new JPanel();
		LabDocTabbedPane = new JTabbedPane();
		panel1 = new JPanel();
		FileLocationField = new JTextField();
		FileLocationLabel = new JLabel();
		FileBrowseButton = new JButton();
		FileTitleLabel = new JLabel();
		FileTitleField = new JTextField();
		panel2 = new JPanel();
		label3 = new JLabel();
		URLTitleField = new JTextField();
		label1 = new JLabel();
		URLField = new JTextField();
		buttonBar = new JPanel();
		SaveButton = new JButton();
		cancelButton = new JButton();
		CellConstraints cc = new CellConstraints();

		//======== this ========
		setTitle("Lab Document");
		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout());

		//======== dialogPane ========
		{
			dialogPane.setBorder(Borders.DIALOG_BORDER);
			dialogPane.setLayout(new BorderLayout());

			//======== contentPanel ========
			{
				contentPanel.setLayout(new BoxLayout(contentPanel, BoxLayout.X_AXIS));

				//======== LabDocTabbedPane ========
				{

					//======== panel1 ========
					{
						panel1.setLayout(new FormLayout(
							"3*(default, $lcgap), 74dlu, $lcgap, default",
							"2*(default, $lgap), default"));

						//---- FileLocationField ----
						FileLocationField.setEditable(false);
						panel1.add(FileLocationField, cc.xywh(3, 3, 5, 1));

						//---- FileLocationLabel ----
						FileLocationLabel.setText("file location");
						FileLocationLabel.setHorizontalAlignment(SwingConstants.CENTER);
						panel1.add(FileLocationLabel, cc.xy(1, 3));

						//---- FileBrowseButton ----
						FileBrowseButton.setText("browse");
						FileBrowseButton.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent e) {
								FileBrowseButtonActionPerformed(e);
							}
						});
						panel1.add(FileBrowseButton, cc.xy(9, 3));

						//---- FileTitleLabel ----
						FileTitleLabel.setText("title");
						FileTitleLabel.setHorizontalAlignment(SwingConstants.CENTER);
						panel1.add(FileTitleLabel, cc.xy(1, 1));
						panel1.add(FileTitleField, cc.xywh(3, 1, 7, 1));
					}
					LabDocTabbedPane.addTab("File", panel1);


					//======== panel2 ========
					{
						panel2.setLayout(new FormLayout(
							"17dlu, $lcgap, 19dlu, $lcgap, 21dlu, $lcgap, default, $lcgap, 122dlu",
							"2*(default, $lgap), default"));

						//---- label3 ----
						label3.setText("Title");
						label3.setHorizontalAlignment(SwingConstants.CENTER);
						panel2.add(label3, cc.xywh(1, 1, 3, 1));
						panel2.add(URLTitleField, cc.xywh(5, 1, 5, 1));

						//---- label1 ----
						label1.setText("URL");
						label1.setHorizontalAlignment(SwingConstants.CENTER);
						panel2.add(label1, cc.xywh(1, 3, 3, 1));
						panel2.add(URLField, cc.xywh(5, 3, 5, 1));
					}
					LabDocTabbedPane.addTab("External Document", panel2);

				}
				contentPanel.add(LabDocTabbedPane);
			}
			dialogPane.add(contentPanel, BorderLayout.CENTER);

			//======== buttonBar ========
			{
				buttonBar.setBorder(Borders.BUTTON_BAR_GAP_BORDER);
				buttonBar.setLayout(new FormLayout(
					"$glue, $button, $rgap, $button",
					"pref"));

				//---- SaveButton ----
				SaveButton.setText("Save");
				SaveButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						SaveButtonActionPerformed(e);
					}
				});
				buttonBar.add(SaveButton, cc.xy(2, 1));

				//---- cancelButton ----
				cancelButton.setText("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						cancelButtonActionPerformed(e);
					}
				});
				buttonBar.add(cancelButton, cc.xy(4, 1));
			}
			dialogPane.add(buttonBar, BorderLayout.SOUTH);
		}
		contentPane.add(dialogPane, BorderLayout.CENTER);
		pack();
		setLocationRelativeTo(getOwner());
		// JFormDesigner - End of component initialization  //GEN-END:initComponents
	}

	// JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables
	private JPanel dialogPane;
	private JPanel contentPanel;
	private JTabbedPane LabDocTabbedPane;
	private JPanel panel1;
	private JTextField FileLocationField;
	private JLabel FileLocationLabel;
	private JButton FileBrowseButton;
	private JLabel FileTitleLabel;
	private JTextField FileTitleField;
	private JPanel panel2;
	private JLabel label3;
	private JTextField URLTitleField;
	private JLabel label1;
	private JTextField URLField;
	private JPanel buttonBar;
	private JButton SaveButton;
	private JButton cancelButton;
	// JFormDesigner - End of variables declaration  //GEN-END:variables
}
