/*
 * Created by JFormDesigner on Fri Dec 11 23:04:24 EST 2009
 */

package WebBuilder;

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.sql.SQLException;

import javax.swing.*;
import com.jgoodies.forms.factories.*;
import com.jgoodies.forms.layout.*;

/**
 * @author Someone
 */
public class ScheduleEventframe extends JFrame {
	int schedID;
	int eventID;

	WebpageDB webDB;
	public ScheduleEventframe(WebpageDB db, int event_ID, int pelement_ID) {
		schedID = pelement_ID;
		eventID = event_ID;
		webDB = db;
		initComponents();
		
		if( eventID!=-1) {
//	"CREATE TABLE sched_event( ID INTEGER IDENTITY, schedID INTEGER, MON BOOLEAN, TUE BOOLEAN, WED BOOLEAN, THU BOOLEAN, FRI BOOLEAN, starttime INTEGER, endtime INTEGER, event_text VARCHAR(30))");
			try {
				Boolean MON = Boolean.parseBoolean(webDB.query_single("select MON from sched_event where ID = " + eventID).toString());
				Boolean TUE = Boolean.parseBoolean(webDB.query_single("select TUE from sched_event where ID = " + eventID).toString());
				Boolean WED = Boolean.parseBoolean(webDB.query_single("select WED from sched_event where ID = " + eventID).toString());
				Boolean THU = Boolean.parseBoolean(webDB.query_single("select THU from sched_event where ID = " + eventID).toString());
				Boolean FRI = Boolean.parseBoolean(webDB.query_single("select FRI from sched_event where ID = " + eventID).toString());
				String starttime = webDB.query_single("select starttime from sched_event where ID = " + eventID).toString();
				String endtime = webDB.query_single("select endtime from sched_event where ID = " + eventID).toString();
				String event_text = webDB.query_single("select event_text from sched_event where ID = " + eventID).toString();
				
				if (MON) {
					MonBox.setSelected(true);
				} else {
					MonBox.setSelected(false);
				}
				if (TUE) {
					TueBox.setSelected(true);
				} else {
					TueBox.setSelected(false);
				}
				if (WED) {
					WedBox.setSelected(true);
				} else {
					WedBox.setSelected(false);
				}
				if (THU) {
					ThuBox.setSelected(true);
				} else {
					ThuBox.setSelected(false);
				}
				if (FRI) {
					FriBox.setSelected(true);
				} else {
					FriBox.setSelected(false);
				}
				
				StartTimeComboBox.setSelectedItem(starttime);
				EndTimeComboBox.setSelectedItem(endtime);
				EventTextField.setText(event_text);
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	private void cancelButtonActionPerformed(ActionEvent e) {
		this.setVisible(false);
		this.dispose();
		
	}

	private void SaveButtonActionPerformed(ActionEvent e) {
		//if the event id = -1 insert
		//if the event id != -1 update
		if (EventTextField.getText().isEmpty()) {
			Interface.ShowMessgaeBox("Please enter text describing the event in the event text field.");
			return;
		}		
		if (!MonBox.isSelected() && !TueBox.isSelected() && !WedBox.isSelected() && !ThuBox.isSelected() && !FriBox.isSelected()) {
			Interface.ShowMessgaeBox("Please select a day or days on which the event occurs.");
			return;
		}
		if (eventID==-1) {
//			webDB.update("INSERT INTO html_element(title, html_text) VALUES('" + HTMLTitleField.getText() + "', '" + hTMLEditor1.getDocumentBody() + "')");
			String InsertSQL = "INSERT INTO sched_event(schedID, MON,TUE,WED,THU,FRI,starttime,endtime,event_text) VALUES(";
			String Values = schedID + ", ";
			if (MonBox.isSelected()) {
				Values = Values + "True, ";
			} else {
				Values = Values + "False, ";
			}
			if (TueBox.isSelected()) {
				Values = Values + "True, ";
			} else {
				Values = Values + "False, ";
			}
			if (WedBox.isSelected()) {
				Values = Values + "True, ";
			} else {
				Values = Values + "False, ";
			}
			if (ThuBox.isSelected()) {
				Values = Values + "True, ";
			} else {
				Values = Values + "False, ";
			}			
			if (FriBox.isSelected()) {
				Values = Values + "True, ";
			} else {
				Values = Values + "False, ";
			}			
			Values = Values + "'" + StartTimeComboBox.getSelectedItem().toString().substring(0, 1) + "', ";
			Values = Values + "'" + EndTimeComboBox.getSelectedItem().toString().substring(0, 1) + "', ";
			Values = Values + "'" + EventTextField.getText().replace("'", "''") + "'";
			InsertSQL = InsertSQL + Values + ")";
			try {
				webDB.update(InsertSQL);
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
				
		} else {
			String UpdateSQL = "Update sched_event Set ";
			String Values = "";
			if (MonBox.isSelected()) {
				Values = Values + "MON = True, ";
			} else {
				Values = Values + "MON = False, ";
			}
			if (TueBox.isSelected()) {
				Values = Values + "TUE = True, ";
			} else {
				Values = Values + "TUE = False, ";
			}
			if (WedBox.isSelected()) {
				Values = Values + "WED = True, ";
			} else {
				Values = Values + "WED = False, ";
			}
			if (ThuBox.isSelected()) {
				Values = Values + "THU = True, ";
			} else {
				Values = Values + "THU = False, ";
			}			
			if (FriBox.isSelected()) {
				Values = Values + "FRI = True, ";
			} else {
				Values = Values + "FRI = False, ";
			}			
			Values = Values + "starttime = '" + StartTimeComboBox.getSelectedItem() + "', ";
			Values = Values + "endtime = '" + EndTimeComboBox.getSelectedItem() + "', ";
			Values = Values + "event_text = '" + EventTextField.getText() + "' ";
			UpdateSQL = UpdateSQL + Values + " WHERE ID = " + eventID;
			try {
				System.out.print(UpdateSQL);
				webDB.update(UpdateSQL);
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}		

		}
		this.setVisible(false);
		this.dispose();
	}

	private void initComponents() {
		// JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents
		dialogPane = new JPanel();
		contentPanel = new JPanel();
		MonBox = new JCheckBox();
		label4 = new JLabel();
		StartTimeComboBox = new JComboBox();
		EndTimeComboBox = new JComboBox();
		FriBox = new JCheckBox();
		ThuBox = new JCheckBox();
		WedBox = new JCheckBox();
		TueBox = new JCheckBox();
		label8 = new JLabel();
		label9 = new JLabel();
		EventTextField = new JTextField();
		buttonBar = new JPanel();
		SaveButton = new JButton();
		cancelButton = new JButton();
		CellConstraints cc = new CellConstraints();

		//======== this ========
		setTitle("Schedule Event");
		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout());

		//======== dialogPane ========
		{
			dialogPane.setBorder(Borders.DIALOG_BORDER);
			dialogPane.setLayout(new BorderLayout());

			//======== contentPanel ========
			{
				contentPanel.setLayout(new FormLayout(
					"3*(default, $lcgap), 21dlu, $lcgap, 41dlu",
					"7*(default, $lgap), default"));

				//---- MonBox ----
				MonBox.setText("Monday");
				contentPanel.add(MonBox, cc.xy(1, 1));

				//---- label4 ----
				label4.setText("start time");
				contentPanel.add(label4, cc.xy(3, 1));

				//---- StartTimeComboBox ----
				StartTimeComboBox.setModel(new DefaultComboBoxModel(new String[] {
					"8",
					"9",
					"10",
					"11",
					"12",
					"1",
					"2",
					"3",
					"4",
					"5",
					"6",
					"7",
					"8",
					"9"
				}));
				contentPanel.add(StartTimeComboBox, cc.xy(5, 1));

				//---- EndTimeComboBox ----
				EndTimeComboBox.setModel(new DefaultComboBoxModel(new String[] {
					"8",
					"9",
					"10",
					"11",
					"12",
					"1",
					"2",
					"3",
					"4",
					"5",
					"6",
					"7",
					"8",
					"9"
				}));
				contentPanel.add(EndTimeComboBox, cc.xy(5, 3));

				//---- FriBox ----
				FriBox.setText("Friday");
				contentPanel.add(FriBox, cc.xy(1, 9));

				//---- ThuBox ----
				ThuBox.setText("Thursday");
				contentPanel.add(ThuBox, cc.xy(1, 7));

				//---- WedBox ----
				WedBox.setText("Wednesday");
				contentPanel.add(WedBox, cc.xy(1, 5));

				//---- TueBox ----
				TueBox.setText("Tuesday");
				contentPanel.add(TueBox, cc.xy(1, 3));

				//---- label8 ----
				label8.setText("end time");
				contentPanel.add(label8, cc.xy(3, 3));

				//---- label9 ----
				label9.setText("Event Text");
				contentPanel.add(label9, cc.xy(3, 7));
				contentPanel.add(EventTextField, cc.xywh(5, 7, 5, 1));
			}
			dialogPane.add(contentPanel, BorderLayout.CENTER);

			//======== buttonBar ========
			{
				buttonBar.setBorder(Borders.BUTTON_BAR_GAP_BORDER);
				buttonBar.setLayout(new FormLayout(
					"$glue, $button, $rgap, $button",
					"pref"));

				//---- SaveButton ----
				SaveButton.setText("Save");
				SaveButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						SaveButtonActionPerformed(e);
					}
				});
				buttonBar.add(SaveButton, cc.xy(2, 1));

				//---- cancelButton ----
				cancelButton.setText("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						cancelButtonActionPerformed(e);
					}
				});
				buttonBar.add(cancelButton, cc.xy(4, 1));
			}
			dialogPane.add(buttonBar, BorderLayout.SOUTH);
		}
		contentPane.add(dialogPane, BorderLayout.CENTER);
		pack();
		setLocationRelativeTo(getOwner());
		// JFormDesigner - End of component initialization  //GEN-END:initComponents
	}

	// JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables
	private JPanel dialogPane;
	private JPanel contentPanel;
	private JCheckBox MonBox;
	private JLabel label4;
	private JComboBox StartTimeComboBox;
	private JComboBox EndTimeComboBox;
	private JCheckBox FriBox;
	private JCheckBox ThuBox;
	private JCheckBox WedBox;
	private JCheckBox TueBox;
	private JLabel label8;
	private JLabel label9;
	private JTextField EventTextField;
	private JPanel buttonBar;
	private JButton SaveButton;
	private JButton cancelButton;
	// JFormDesigner - End of variables declaration  //GEN-END:variables
}
