/*
 * Created by JFormDesigner on Wed Dec 02 14:17:52 EST 2009
 */

package WebBuilder;

import java.awt.*;
import java.awt.event.*;
import java.sql.SQLException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

import javax.swing.*;
import com.jgoodies.forms.factories.*;
import com.jgoodies.forms.layout.*;

/**
 * @author Someone
 */
public class Sectionframe extends JFrame {
	int section_id ;
	int course_id ;
	int lab_instructor_id1;
	int lab_instructor_id2;
	WebpageDB webDB = null;
	String[][] LabInstructorListArray;
	String[][] UnsetLabListArray;
	String[][] SetLabListArray;
	
	public Sectionframe(WebpageDB db, int id, int c_id) {
		webDB = db;
		section_id = id;
		course_id = c_id;
		initComponents();
		
		if( section_id!=-1) {
			try {

				String title = webDB.query_single("select section_number from section where ID = " + section_id).toString();
				course_id = Integer.parseInt(webDB.query_single("select courseID from section where ID = " + section_id).toString());
				lab_instructor_id1 = Integer.parseInt(webDB.query_single("select lab_instructor_id1 from section where ID = " + section_id).toString());
				lab_instructor_id2 = Integer.parseInt(webDB.query_single("select lab_instructor_id2 from section where ID = " + section_id).toString());
				
				String lab_instructor_name = webDB.query_single("select lab_instructor_name from lab_instructor where ID = " + lab_instructor_id1).toString();
				LabInstructor1DisplayField.setText(lab_instructor_name);
				lab_instructor_name = webDB.query_single("select lab_instructor_name from lab_instructor where ID = " + lab_instructor_id2).toString();
				LabInstructor2DisplayField.setText(lab_instructor_name);
				
				SectionNumberField.setText(title);
				
				LabInstructorLabel.setEnabled(true);
    			LabInstructor1Label.setEnabled(true);
    			LabInstructor2Label.setEnabled(true);
    			LabInstructor1DisplayField.setEnabled(true);
    			LabInstructor2DisplayField.setEnabled(true);
    			SelectLabInstructor1Button.setEnabled(true);
    			SelectLabInstructor2Button.setEnabled(true);
    			AddLabInstructorButton.setEnabled(true);
    			ModifyLabInstructorButton.setEnabled(true);
    			RemoveLabInstructorButton.setEnabled(true);
    			LabInstructorList.setEnabled(true);
    			
    			LabDatesLabel.setEnabled(true);
    			SetLabDateButton.setEnabled(true);
    			SetLabList.setEnabled(true);
    			UnsetLabList.setEnabled(true);
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}	
		}
		LabInstructorList.setListData(getLabInstructorList(webDB));
		SetLabList.setListData(getSetLabList(webDB));
		UnsetLabList.setListData(getUnsetLabList(webDB));
	}

	  private String[] getLabInstructorList(WebpageDB db) {
			String[] returnString = new String[]{"a", "b"};
			Integer page_count;
			
			try {			
				page_count = Integer.valueOf(db.query_single("select count(ID) from lab_instructor").toString());
				if (page_count > 0) {					
					String[][] lab_instructors = db.query_array("select ID, lab_instructor_name FROM lab_instructor");
					LabInstructorListArray = lab_instructors;
					ArrayList<String> titles = new ArrayList<String>();

					for (int i = 0; i <lab_instructors.length;i++ ){
						System.out.print(lab_instructors[i][0] + "\n");
						System.out.print(lab_instructors[i][1] + "\n");
						titles.add("[" + lab_instructors[i][0] + "] " + lab_instructors[i][1]);
					}
					Object[] ObjArray =  titles.toArray();
					
					returnString = new String[ObjArray.length];
					for (int j = 0 ; j<ObjArray.length;j++){
						returnString[j] = ObjArray[j].toString();
					}
				} else {
					returnString = new String[]{};
				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return returnString;
		}	
	
	private void SectionNumberFieldActionPerformed(ActionEvent e) {
		if (!SectionNumberField.getText().isEmpty()) {
			if (section_id == -1) { 

    			try {
    				
    				webDB.update("INSERT INTO section(section_number,courseID) VALUES('" + SectionNumberField.getText() + "', " + course_id + ")");
    				section_id = Integer.valueOf(webDB.query_single("select max(ID) from section").toString());
    				
    			} catch (SQLException e1) {
    				// TODO Auto-generated catch block
    				e1.printStackTrace();
    			}				
    			LabInstructorLabel.setEnabled(true);
    			LabInstructor1Label.setEnabled(true);
    			LabInstructor1DisplayField.setEnabled(true);
    			SelectLabInstructor1Button.setEnabled(true);
    			LabInstructor2Label.setEnabled(true);
    			LabInstructor2DisplayField.setEnabled(true);
    			SelectLabInstructor2Button.setEnabled(true);    			AddLabInstructorButton.setEnabled(true);
    			ModifyLabInstructorButton.setEnabled(true);
    			RemoveLabInstructorButton.setEnabled(true);
    			LabInstructorList.setEnabled(true);
    			
    			LabDatesLabel.setEnabled(true);
    			SetLabDateButton.setEnabled(true);
    			SetLabList.setEnabled(true);
    			UnsetLabList.setEnabled(true);
    			

			}
		} else {
			Interface.ShowMessgaeBox("enter a title for the lab to proceed");
			
		}
		
	}

	private void cancelButtonActionPerformed(ActionEvent e) {
		this.setVisible(false);
		this.dispose();
	}

	private Boolean CheckSectionData() {
		Boolean success= true;
		if (SectionNumberField.getText().isEmpty()) {
			Interface.ShowMessgaeBox("enter a section number to proceed");
			success = false;
		}
		
		if (lab_instructor_id1 == -1) {
			Interface.ShowMessgaeBox("select a primary lab instructor to proceed");
			success = false;
		} 
		if (lab_instructor_id2 == -1) {
			Interface.ShowMessgaeBox("select a secondary lab instructor to proceed");
			success = false;
		} 		

		
		return success;
		
	}
	
	private void SaveButtonActionPerformed(ActionEvent e) {
		Boolean success= false;
		
    	if (!SectionNumberField.getText().isEmpty()) {
    		if (CheckSectionData()) {
				try {
	 //also update the instructorid
					webDB.update("UPDATE Section SET section_number = '" + SectionNumberField.getText() + "', lab_instructor_id1 = " + lab_instructor_id1 + ", lab_instructor_id2 = " + lab_instructor_id2 + " where ID = " + section_id);
					success = true;
				} catch (SQLException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
    		}
		} else {
			Interface.ShowMessgaeBox("enter a section to proceed");
		}		
    	
		if (success) {
			this.setVisible(false);
			this.dispose();
		}
	}

	private void AddLabInstructorButtonActionPerformed(ActionEvent e) {
		LabInstructorframe add_LabInstructorframe = new LabInstructorframe(webDB, -1);
		add_LabInstructorframe.show();	
	}

	private void ModifyLabInstructorButtonActionPerformed(ActionEvent e) {
		if (LabInstructorList.isSelectionEmpty()){
			Interface.ShowMessgaeBox("you must select an item from the lecturer list to be modified");
			
		} else {
			int labinstructor_toMod = LabInstructorList.getSelectedIndex();
			int labinstructor_toMod_ID = Integer.valueOf(LabInstructorListArray[labinstructor_toMod][0]);
			LabInstructorframe mod_LabInstructorframe = new LabInstructorframe(webDB, labinstructor_toMod_ID);
			mod_LabInstructorframe.show();		
		}
	}

	private void thisWindowGainedFocus(WindowEvent e) {
		LabInstructorList.setListData(getLabInstructorList(webDB));
		SetLabList.setListData(getSetLabList(webDB));
		UnsetLabList.setListData(getUnsetLabList(webDB));
		LabInstructor2DisplayField.setText(LabInstructorListArray[LabInstructorList.getSelectedIndex()][1]);
		LabInstructor2DisplayField.setText(LabInstructorListArray[LabInstructorList.getSelectedIndex()][1]);
	}

	private void SelectLabInstructorButtonActionPerformed(ActionEvent e) {
		if (LabInstructorList.isSelectionEmpty()) {
			  Interface.ShowMessgaeBox("Select a lab instructor to assign to the lab");
			  return;
			  
		  } else {
			  int labins1_id = Integer.valueOf(LabInstructorListArray[LabInstructorList.getSelectedIndex()][0]);
			  lab_instructor_id1 = labins1_id;
		  }
		LabInstructor1DisplayField.setText(LabInstructorListArray[LabInstructorList.getSelectedIndex()][1]);
	}

	private void SetLabDateButtonActionPerformed(ActionEvent e) {
		  if (SetLabList.isSelectionEmpty() && UnsetLabList.isSelectionEmpty()) {
			  Interface.ShowMessgaeBox("Select a lab to set its date information for the section");
			  return;
		  } else {
			  int lab_id;
			  if (SetLabList.isSelectionEmpty()) {
				  lab_id = Integer.valueOf(UnsetLabListArray[UnsetLabList.getSelectedIndex()][0]);
				  
				  SetLabDateframe set_LabDateframe = new SetLabDateframe(webDB, -1, section_id, lab_id);
				  set_LabDateframe.show();	
			  }else {
				  int ref_id = Integer.valueOf(SetLabListArray[SetLabList.getSelectedIndex()][0]);
				  SetLabDateframe set_LabDateframe = new SetLabDateframe(webDB, ref_id, -1, -1);
				  set_LabDateframe.show();
			  }
		  }
	}
	  private String[] getUnsetLabList(WebpageDB db) {
			String[] returnString = new String[]{"a", "b"};
			Integer unset_lab_count;
			
			try {			
//"CREATE TABLE ref_section_lab( ID INTEGER IDENTITY, sectionID INTEGER, labID INTEGER, lab_date DATE, lab_time VARCHAR(20))");
				unset_lab_count = Integer.valueOf(db.query_single("select count(lab.ID) FROM lab WHERE courseID ='" + course_id + "' and  ID NOT IN (select lab.ID FROM lab inner join ref_section_lab on lab.ID = ref_section_lab.labID where ref_section_lab.sectionID = " + section_id + ")").toString());
				if (unset_lab_count > 0) {					
					String[][] labs = db.query_array("select lab.ID, title FROM lab WHERE courseID ='" + course_id + "' and  ID NOT IN (select lab.ID FROM lab inner join ref_section_lab on lab.ID = ref_section_lab.labID where ref_section_lab.sectionID = " + section_id + ")");
					UnsetLabListArray = labs;
					ArrayList<String> titles = new ArrayList<String>();

					for (int i = 0; i <labs.length;i++ ){
						System.out.print(labs[i][0] + "\n");
						System.out.print(labs[i][1] + "\n");
						titles.add("[" + labs[i][0] + "] " + labs[i][1]);
					}
					Object[] ObjArray =  titles.toArray();
					
					returnString = new String[ObjArray.length];
					for (int j = 0 ; j<ObjArray.length;j++){
						returnString[j] = ObjArray[j].toString();
					}
				} else {
					returnString = new String[]{};
				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return returnString;
		}		  
	  
	  private String[] getSetLabList(WebpageDB db) {
			String[] returnString = new String[]{"a", "b"};
			Integer set_lab_count;
			
			try {
//            	"CREATE TABLE ref_section_lab( ID INTEGER IDENTITY, sectionID INTEGER, labID INTEGER, lab_date DATE, lab_time VARCHAR(20))");
				set_lab_count = Integer.valueOf(db.query_single("select count(ID) from ref_section_lab where sectionID = " + section_id).toString());
				
				if (set_lab_count > 0) {					
					String[][] labs = db.query_array("select ref_section_lab.ID, title,  lab_date, lab_time FROM lab inner join ref_section_lab on lab.ID = ref_section_lab.labID where ref_section_lab.sectionID = " + section_id);
					SetLabListArray = labs;
					ArrayList<String> titles = new ArrayList<String>();

					for (int i = 0; i <labs.length;i++ ){
						System.out.print(labs[i][0] + "\n");
						System.out.print(labs[i][1] + "\n");
						titles.add("[" + labs[i][0] + "] " + labs[i][1] + " " + labs[i][2]+ " " + labs[i][3]);
					}
					Object[] ObjArray =  titles.toArray();
					
					returnString = new String[ObjArray.length];
					for (int j = 0 ; j<ObjArray.length;j++){
						returnString[j] = ObjArray[j].toString();
					}
				} else {
					returnString = new String[]{};
				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return returnString;
		}	

		private void SetLabListFocusGained(FocusEvent e) {
			// TODO add your code here
			UnsetLabList.clearSelection();
		}

		private void UnsetLabList2FocusGained(FocusEvent e) {
			// TODO add your code here
			
		}

		private void SelectLabInstructor2ButtonActionPerformed(ActionEvent e) {
			if (LabInstructorList.isSelectionEmpty()) {
				  Interface.ShowMessgaeBox("Select a lab instructor to assign to the lab");
				  return;
				  
			  } else {
				  int labins2_id = Integer.valueOf(LabInstructorListArray[LabInstructorList.getSelectedIndex()][0]);
				  lab_instructor_id2 = labins2_id;
			  }
			LabInstructor2DisplayField.setText(LabInstructorListArray[LabInstructorList.getSelectedIndex()][1]);
		}

		private void SelectLabInstructor1ButtonActionPerformed(ActionEvent e) {
			if (LabInstructorList.isSelectionEmpty()) {
				  Interface.ShowMessgaeBox("Select a lab instructor to assign to the lab");
				  return;
				  
			  } else {
				  int labins1_id = Integer.valueOf(LabInstructorListArray[LabInstructorList.getSelectedIndex()][0]);
				  lab_instructor_id1 = labins1_id;
			  }
			LabInstructor1DisplayField.setText(LabInstructorListArray[LabInstructorList.getSelectedIndex()][1]);
		}

		private void UnsetLabListFocusGained(FocusEvent e) {
			SetLabList.clearSelection();
		}

		private void RemoveLabInstructorButtonActionPerformed(ActionEvent e) {
			if (LabInstructorList.isSelectionEmpty()){
				Interface.ShowMessgaeBox("you must select an item from the lab coordinator list to be removed");
			} else {
				int lab_inst_used_count;
				try {
					int lab_instructor_toRemove =LabInstructorList.getSelectedIndex();
					int lab_instructor_toRemove_ID = Integer.valueOf(LabInstructorListArray[lab_instructor_toRemove][0]);
					//lab_instructor_id1 INTEGER, lab_instructor_id2 
					lab_inst_used_count = Integer.valueOf(webDB.query_single("select count(ID) from section where lab_instructor_id1 = " + lab_instructor_toRemove_ID + " or lab_instructor_id2 = " + lab_instructor_toRemove_ID + " and ID != " + section_id).toString());
					if (lab_inst_used_count >0 ) {
						Interface.ShowMessgaeBox("the lab coordinator cannot be removed because they are being used in another course");
					} else {
						webDB.update("DELETE FROM lab_coordinator where id = " +  lab_instructor_toRemove_ID);
					}
				} catch (NumberFormatException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (SQLException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				LabInstructorList.setListData(getLabInstructorList(webDB));
			}
		}
	private void initComponents() {
		// JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents
		dialogPane = new JPanel();
		contentPanel = new JPanel();
		label1 = new JLabel();
		SectionNumberField = new JTextField();
		LabInstructor1Label = new JLabel();
		LabInstructor1DisplayField = new JTextField();
		SelectLabInstructor1Button = new JButton();
		LabInstructor2Label = new JLabel();
		LabInstructor2DisplayField = new JTextField();
		SelectLabInstructor2Button = new JButton();
		LabInstructorLabel = new JLabel();
		AddLabInstructorButton = new JButton();
		ModifyLabInstructorButton = new JButton();
		RemoveLabInstructorButton = new JButton();
		scrollPane2 = new JScrollPane();
		LabInstructorList = new JList();
		LabDatesLabel = new JLabel();
		SetLabDateButton = new JButton();
		scrollPane1 = new JScrollPane();
		SetLabList = new JList();
		scrollPane3 = new JScrollPane();
		UnsetLabList = new JList();
		buttonBar = new JPanel();
		SaveButton = new JButton();
		cancelButton = new JButton();
		CellConstraints cc = new CellConstraints();

		//======== this ========
		setTitle("Section");
		addWindowFocusListener(new WindowAdapter() {
			@Override
			public void windowGainedFocus(WindowEvent e) {
				thisWindowGainedFocus(e);
			}
		});
		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout());

		//======== dialogPane ========
		{
			dialogPane.setBorder(Borders.DIALOG_BORDER);
			dialogPane.setLayout(new BorderLayout());

			//======== contentPanel ========
			{
				contentPanel.setLayout(new FormLayout(
					"57dlu, $lcgap, 33dlu, 2*($lcgap, 37dlu), $lcgap, 35dlu, $lcgap, 33dlu, $lcgap, 18dlu, $lcgap, 26dlu",
					"7*(default, $lgap), default"));

				//---- label1 ----
				label1.setText("Section Number");
				contentPanel.add(label1, cc.xywh(1, 1, 3, 1));

				//---- SectionNumberField ----
				SectionNumberField.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						SectionNumberFieldActionPerformed(e);
					}
				});
				contentPanel.add(SectionNumberField, cc.xywh(5, 1, 3, 1));

				//---- LabInstructor1Label ----
				LabInstructor1Label.setText("Primary Lab Instructor");
				LabInstructor1Label.setEnabled(false);
				contentPanel.add(LabInstructor1Label, cc.xywh(1, 3, 3, 1));

				//---- LabInstructor1DisplayField ----
				LabInstructor1DisplayField.setEnabled(false);
				LabInstructor1DisplayField.setEditable(false);
				contentPanel.add(LabInstructor1DisplayField, cc.xywh(5, 3, 5, 1));

				//---- SelectLabInstructor1Button ----
				SelectLabInstructor1Button.setText("Select");
				SelectLabInstructor1Button.setEnabled(false);
				SelectLabInstructor1Button.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						SelectLabInstructor1ButtonActionPerformed(e);
					}
				});
				contentPanel.add(SelectLabInstructor1Button, cc.xywh(11, 3, 3, 1));

				//---- LabInstructor2Label ----
				LabInstructor2Label.setText("Secondary Lab Instructor");
				LabInstructor2Label.setEnabled(false);
				contentPanel.add(LabInstructor2Label, cc.xywh(1, 5, 3, 1));

				//---- LabInstructor2DisplayField ----
				LabInstructor2DisplayField.setEnabled(false);
				LabInstructor2DisplayField.setEditable(false);
				contentPanel.add(LabInstructor2DisplayField, cc.xywh(5, 5, 5, 1));

				//---- SelectLabInstructor2Button ----
				SelectLabInstructor2Button.setText("Select");
				SelectLabInstructor2Button.setEnabled(false);
				SelectLabInstructor2Button.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						SelectLabInstructor2ButtonActionPerformed(e);
					}
				});
				contentPanel.add(SelectLabInstructor2Button, cc.xywh(11, 5, 3, 1));

				//---- LabInstructorLabel ----
				LabInstructorLabel.setText("Lab Instructors");
				LabInstructorLabel.setEnabled(false);
				contentPanel.add(LabInstructorLabel, cc.xy(1, 7));

				//---- AddLabInstructorButton ----
				AddLabInstructorButton.setText("+");
				AddLabInstructorButton.setEnabled(false);
				AddLabInstructorButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						AddLabInstructorButtonActionPerformed(e);
					}
				});
				contentPanel.add(AddLabInstructorButton, cc.xy(3, 7));

				//---- ModifyLabInstructorButton ----
				ModifyLabInstructorButton.setText("~");
				ModifyLabInstructorButton.setEnabled(false);
				ModifyLabInstructorButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						ModifyLabInstructorButtonActionPerformed(e);
					}
				});
				contentPanel.add(ModifyLabInstructorButton, cc.xy(5, 7));

				//---- RemoveLabInstructorButton ----
				RemoveLabInstructorButton.setText("-");
				RemoveLabInstructorButton.setEnabled(false);
				RemoveLabInstructorButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						RemoveLabInstructorButtonActionPerformed(e);
					}
				});
				contentPanel.add(RemoveLabInstructorButton, cc.xy(7, 7));

				//======== scrollPane2 ========
				{

					//---- LabInstructorList ----
					LabInstructorList.setEnabled(false);
					scrollPane2.setViewportView(LabInstructorList);
				}
				contentPanel.add(scrollPane2, cc.xywh(1, 9, 7, 1));

				//---- LabDatesLabel ----
				LabDatesLabel.setText("Lab Dates");
				LabDatesLabel.setEnabled(false);
				contentPanel.add(LabDatesLabel, cc.xywh(1, 11, 3, 1));

				//---- SetLabDateButton ----
				SetLabDateButton.setText("Set Date");
				SetLabDateButton.setEnabled(false);
				SetLabDateButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						SetLabDateButtonActionPerformed(e);
					}
				});
				contentPanel.add(SetLabDateButton, cc.xywh(5, 11, 4, 1));

				//======== scrollPane1 ========
				{

					//---- SetLabList ----
					SetLabList.setEnabled(false);
					SetLabList.addFocusListener(new FocusAdapter() {
						@Override
						public void focusGained(FocusEvent e) {
							SetLabListFocusGained(e);
						}
					});
					scrollPane1.setViewportView(SetLabList);
				}
				contentPanel.add(scrollPane1, cc.xywh(1, 13, 3, 1));

				//======== scrollPane3 ========
				{

					//---- UnsetLabList ----
					UnsetLabList.setEnabled(false);
					UnsetLabList.addFocusListener(new FocusAdapter() {
						@Override
						public void focusGained(FocusEvent e) {
							UnsetLabListFocusGained(e);
						}
					});
					scrollPane3.setViewportView(UnsetLabList);
				}
				contentPanel.add(scrollPane3, cc.xywh(8, 13, 5, 1));
			}
			dialogPane.add(contentPanel, BorderLayout.EAST);

			//======== buttonBar ========
			{
				buttonBar.setBorder(Borders.BUTTON_BAR_GAP_BORDER);
				buttonBar.setLayout(new FormLayout(
					"$glue, $button, $rgap, $button",
					"pref"));

				//---- SaveButton ----
				SaveButton.setText("Save");
				SaveButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						SaveButtonActionPerformed(e);
					}
				});
				buttonBar.add(SaveButton, cc.xy(2, 1));

				//---- cancelButton ----
				cancelButton.setText("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						cancelButtonActionPerformed(e);
					}
				});
				buttonBar.add(cancelButton, cc.xy(4, 1));
			}
			dialogPane.add(buttonBar, BorderLayout.SOUTH);
		}
		contentPane.add(dialogPane, BorderLayout.CENTER);
		pack();
		setLocationRelativeTo(getOwner());
		// JFormDesigner - End of component initialization  //GEN-END:initComponents
	}

	// JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables
	private JPanel dialogPane;
	private JPanel contentPanel;
	private JLabel label1;
	private JTextField SectionNumberField;
	private JLabel LabInstructor1Label;
	private JTextField LabInstructor1DisplayField;
	private JButton SelectLabInstructor1Button;
	private JLabel LabInstructor2Label;
	private JTextField LabInstructor2DisplayField;
	private JButton SelectLabInstructor2Button;
	private JLabel LabInstructorLabel;
	private JButton AddLabInstructorButton;
	private JButton ModifyLabInstructorButton;
	private JButton RemoveLabInstructorButton;
	private JScrollPane scrollPane2;
	private JList LabInstructorList;
	private JLabel LabDatesLabel;
	private JButton SetLabDateButton;
	private JScrollPane scrollPane1;
	private JList SetLabList;
	private JScrollPane scrollPane3;
	private JList UnsetLabList;
	private JPanel buttonBar;
	private JButton SaveButton;
	private JButton cancelButton;
	// JFormDesigner - End of variables declaration  //GEN-END:variables
}
