package oldApps;

import java.applet.Applet; 
import java.awt.Button;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

@SuppressWarnings("serial")
public class Acceleration extends Applet {
	
	private int ballx,ballxi,xpos,place=0,maxval,yvelocity,bally,ballyi,ypos,holder=0,timex;
	private double vox,xox,voy,ay,time;
	private boolean running = false, caughtException = false,paused=false,hitend=false,restarting=false;
	private ArrayList<Integer> myArrx,myArry,myArrx1,myArry1,myArrx2,myArry2,myArrx3,myArry3;
	private TextField tf, tf1, tf2;
	
	@Override
	public void init(){
		//Initialize values used later in code
			time =0;
			ballx = 35; ballxi = 35;
			bally = 715; ballyi = 715;
			ay = 9.8;
			xpos = 0; ypos =0;
			//Setup the holders for the ball path depending on place, which holds the current 
			//array number for the ball path
			switch(place){
			case 0:
				myArrx = new ArrayList<Integer>(1);
				myArry = new ArrayList<Integer>(1);
				break;
			case 1:
				myArrx1 = new ArrayList<Integer>(1);
				myArry1 = new ArrayList<Integer>(1);
				break;
			case 2:
				myArrx2 = new ArrayList<Integer>(1);
				myArry2 = new ArrayList<Integer>(1);
				break;
			case 3:
				myArrx3 = new ArrayList<Integer>(1);
				myArry3 = new ArrayList<Integer>(1);
				break;
			}
			
			//If the program is not restarting, then draw the panel
			if(restarting==false){
				Panel panel = new Panel();
				Label label = new Label("Enter the Initial x-velocity");
				panel.add(label);
				tf = new TextField(5);
				panel.add(tf);
				label = new Label("Enter Initial y-position (0-700)");
				panel.add(label);
				tf1 = new TextField(5);
				panel.add(tf1);
				label = new Label("Enter the Initial y-velocity (-120-120)");
				panel.add(label);
				tf2 = new TextField(5);
				panel.add(tf2);
				Button button = new Button("  RUN  ");
				button.addActionListener(new buttonMenu(0));
				panel.add(button);
				button = new Button("RESTART");
				button.addActionListener(new buttonMenu(1));
				panel.add(button);
				button = new Button(" PAUSE ");
				button.addActionListener(new buttonMenu(2));
				panel.add(button);
				add(panel);
			}

			repaint();
			}
	@Override
	public void paint(Graphics g){
		//Setup for grid
			//Set color to black
			g.setColor(Color.BLACK);
			//draw grid lines
			g.drawLine(40, 40, 40, 740);
			g.drawLine(39, 40, 39, 740);
			g.drawLine(41, 40, 41, 740);
			g.drawLine(20, 719, 1040, 719);
			g.drawLine(20, 721, 1040, 721);
			g.drawLine(20, 720, 1040, 720);
			g.drawLine(20, 620, 1040, 620);
			g.drawLine(20, 520, 1040, 520);
			g.drawLine(20, 420, 1040, 420);
			g.drawLine(20, 320, 1040, 320);
			g.drawLine(20, 220, 1040, 220);
			g.drawLine(20, 120, 740, 120);
			g.drawLine(140,20, 140,740);
			g.drawLine(240,20, 240,740);
			g.drawLine(340,20, 340,740);
			g.drawLine(440,20, 440,740);
			g.drawLine(540,20, 540,740);
			g.drawLine(640,20, 640,740);
			g.drawLine(740,20, 740,740);
			g.drawLine(840,220, 840,740);
			g.drawLine(940,220, 940,740);
		//Setup for Y velocity Graph
			g.drawLine(810,60,810,180);
			g.drawLine(810, 120, 840, 120);
			//Set color to Magenta
			g.setColor(Color.MAGENTA);
			//Write label
			g.drawString("Y Velocity", 750, 125);
			//Logic code to draw the velocity bar graph depending on the sign of the velocity
			if(yvelocity>=0){
				g.fillRect(815, 120-yvelocity/2, 20, abs(yvelocity)/2);
				g.drawString(""+abs(yvelocity)/2, 845, 125);}
			if(yvelocity<0){
				g.fillRect(815, 120, 20, abs(yvelocity));
				g.drawString("-"+abs(yvelocity), 845, 125);
			}
		//Setup for Statistics Corner
			g.setColor(Color.GREEN);
			g.drawString("Max Height Reached: ", 855, 60);
			g.drawString("Time in Air: "+timex, 855, 80);
		//Setup for Ball Path
			g.setColor(Color.RED);
			g.fillOval(ballx, bally, 10, 10);
			//Logic to determine which ball path to draw
			
				if((place==0&&time!=0)||holder>0){	
					for(int a=0;a<myArrx.size();a++){
						g.setColor(Color.RED);
						g.fillOval(myArrx.get(a), myArry.get(a), 5, 5);}}
				if(holder>1||(place==1&&time!=0)){
					for(int a=0;a<myArrx1.size();a++){
					g.setColor(Color.BLUE);
						g.fillOval(myArrx1.get(a), myArry1.get(a), 5, 5);}}
				if(holder>2||(place==2&&time!=0)){
					for(int a=0;a<myArrx2.size();a++){
					g.setColor(Color.GREEN);
						g.fillOval(myArrx2.get(a), myArry2.get(a), 5, 5);}}
				if(holder>3||(place==3&&time!=0)){
					for(int a=0;a<myArrx3.size();a++){
						g.setColor(Color.CYAN);
						g.fillOval(myArrx3.get(a), myArry3.get(a), 5, 5);}}
				g.setColor(Color.RED);
				g.fillRect(ballx+2, 720, 5, 10);
				g.fillRect(30, bally+2, 10, 5);
				//Writes the coordinates of the ball at each instant in time
				g.setColor(Color.BLUE);
				g.drawString("("+xpos+" , "+ypos+")",ballx-5,bally-5);
				g.drawString("("+xpos+")", ballx+15, 735);
				g.drawString("("+ypos+")", 20, bally+15);
				//Write the highest point only when the ball has reached the end
				g.setColor(Color.GREEN);
				if(hitend==true){
					g.drawString("Max Height Reached: "+maxval, 855, 60);}
				
		//Run the ball in flight code only if the run button has been clicked,
		//the pause function is not enabled, and the ball has not yet hit the end
		if(running==true&&paused==false&&hitend==false){
			runit();
		}
	}
	
	public void runit(){
			//try catch block used to slow code run
			try {
				Thread.sleep(125);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			//logic to determine if the ball has reached the end of flight
			if(time!=0&&ypos<=0){
				hitend=true;
			}
			//While the  ball is still in the air, perform the equations to determine movement
			if(hitend==false){
			time = time+(.2);
			timex = (int) time;
			ballx = (int) (ballxi+(vox*time));
			xpos = (int) ((vox*time));
			ypos = (int) ((xox+voy*time-((.5)*ay*time*time)));
			bally = (int) (ballyi+(-xox-voy*time+((.5)*ay*time*time)));
			yvelocity = (int) ((voy-ay*time));
			//stores the path of the ball into the correct arrayList
			if(place==0){
				myArrx.add(ballx);
				myArry.add(bally);
			}
			if(place==1){
				myArrx1.add(ballx);
				myArry1.add(bally);
			}
			if(place==2){
				myArrx2.add(ballx);
				myArry2.add(bally);
			}
			if(place==3){
				myArrx3.add(ballx);
				myArry3.add(bally);
			}
		//Run paint
		repaint();
	}
				//calculates the maximum value based on the input conditions 
			if(hitend==true){	
			maximum();}
	}
	public void maximum(){
		int maxy = (int) ((-voy)/(-ay));
		if(maxy<0){
			maxy=0;
		}
		maxval = (int) (xox+voy*maxy-(.5)*ay*maxy*maxy);
		repaint();
	}
	public int abs(int a){
		//A function used to find the absolute value of an integer. Used in the Y-Velocity graph
		if(a<0){
			a=a*-1;
		}
		return a;
	}
	
	public class buttonMenu implements ActionListener{
		private int what;
		//Constructor for the ButtonMenu. The function of each button depends on its integer value
		public buttonMenu(int a){
			what = a;
		}
		public void actionPerformed(ActionEvent arg0) {
			//If the run button is pressed, and the ball isn't already in run mode:
			if(what==0&&running==false){
				//Try to turn the values in each of the text fields into an integer.
				try{
					vox = Double.parseDouble(tf.getText());
					xox = Double.parseDouble(tf1.getText());
					voy = Double.parseDouble(tf2.getText());
					//Check that values are within bounds
					//Initial x velocity must be greater than zero
					if(xox<0){
						xox=0;
						tf1.setText(""+0);
					}
					
					if(xox>700){
						xox=700;
						tf1.setText(""+700);
					}	
					if(vox<0){
						vox=0;
						tf.setText(""+0);
					}
					if(voy>120){
						voy=120;
						tf2.setText(""+120);
					}
					if(voy<-120){
						voy=-120;
						tf2.setText(""+-120);
					}
				}
				//if there was an exception trying to parse the values to ints, then make the boolean value
				//caughtException true
				catch(Exception e){
					caughtException = true;
				}
				//As long as there wasn't an exception, the values were entered properly, and the ball can be put into run mode
				if(caughtException==false){
				running=true;
				paused=false;
				}
				caughtException=false;
				repaint();
			}
			if(what==0&&running==true){
				restarting=false;
						}
			//Restart button was pressed, change all the values to their initial states, then run the initializer
			//with the boolean value of restarting true
			if(what==1&&restarting!=true){
				if(running=true){
					if(place==3){
						place=-1;
					}
					place++;
					holder++;
					restarting=true;
					running =false;
					paused =false;
					hitend=false;
					init();
				}
				repaint();
			}
			//Pause button was pressed, change the value of the boolean paused to the opposite of what it was
			if(what==2){
				paused = !paused;
				repaint();
			}
		}
	}
}