package oldApps;

import java.applet.Applet;
import java.awt.Button;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

@SuppressWarnings("serial")
public class Collision extends Applet
{

	private Panel panel;
	private TextField mass1, mass2, veloc1, veloc2;
	private Label label;
	private Button button;
	private double massA, massB, velocA, velocB, time, time2, collision, vfa, vfb,vfat,vfbt;
	private boolean running, restart = false, collide;

	public Collision()
	{
		initialize();
	}
	
	public void initialize()
	{
		time2=0;
		time = 0;
		collide = false;
		if (restart == false)
			{
			panel = new Panel();
			label = new Label("Mass of Object 1(500-2000):");
			panel.add(label);
			mass1 = new TextField(5);
			panel.add(mass1);
			label = new Label("Velocity of Object 1(0-25):");
			panel.add(label);
			veloc1 = new TextField(5);
			panel.add(veloc1);
			label = new Label("Mass of Object 2(500-2000):");
			panel.add(label);
			mass2 = new TextField(5);
			panel.add(mass2);
			label = new Label("Velocity of Object 2(0-25):");
			panel.add(label);
			veloc2 = new TextField(5);
			panel.add(veloc2);
			button = new Button(" RUN ");
			button.addActionListener(new buttonMenu(0));
			panel.add(button);
			button = new Button("RESET");
			button.addActionListener(new buttonMenu(1));
			panel.add(button);
			add(panel);
		}
		repaint();
	}

	public void paint(Graphics g)
	{
		g.drawString("Initial Velocity of Cart 1: "+velocA, 20, 250);
		g.drawString("Initial Velocity of Cart 2: "+(-velocB), 20, 300);
		g.drawLine(20, 500, 1000, 500);
		g.drawLine(20, 450, 20, 550);
		g.drawString("V", 20, 430);
		for (int a = 1; a < 21; a++)
		{
			g.drawLine(20 + a * 49, 490, 20 + a * 49, 510);}
		if (!collide&&running)
		{
			g.setColor(Color.BLUE);
			g.drawLine(20, (int)(500 - velocA), (int)(20 + time * 20), (int)(500 - velocA));
			g.fillOval((int)(300 + (time * velocA)), (int)(150 - (massA/40)), (int)(massA/20), (int)(massA/20));
			g.setColor(Color.RED);
			g.drawLine(20, (int)(500 + velocB), (int)(20 + time * 20), (int)(500 +velocB));
			g.fillOval((int)(700 - (time * velocB)), (int)(150 - (massB/40)), (int)(massB/20), (int)(massB/20));
			g.drawString(""+(int) massA, (int)(310 + (time * velocA)), (150));
			g.setColor(Color.BLUE);
			g.drawString(""+(int) massB, (int)(690- (time * velocB)),150);}
		if (collide == true && running == true)
		{
			g.setColor(Color.BLUE);
			g.drawLine((int)(20+time2*20), (int)(500-velocA), (int) (20+time2*20), (int)(500 - vfa));
			g.drawLine(20,(int) (500-velocA),(int)(20+time2*20),(int)(500-velocA));
			g.drawLine((int) (20+time2*20), (int)(500 - vfa), (int)(20 + (time2 + time) * 20), (int)(500 - vfa));
			g.fillOval((int)((300 + collision * velocA) + (time * vfa)),(int)(150 - (massA/40)), (int)(massA/20), (int)(massA/20));
			g.setColor(Color.RED);
			g.drawLine((int)(20+time2*20), (int)(500+velocB), (int) (20+time2*20), (int)(500 + vfb));
			g.drawLine(20,(int) (500+velocB),(int)(20+time2*20),(int)(500+velocB));
			g.drawLine((int) (20+time2*20), (int)(500 + vfb), (int)(20 + (time2 + time) * 20), (int)(500 + vfb));
			g.fillOval((int)((700 - collision * velocB) - (time * vfb)), (int)(150 - (massB/40)), (int)(massB/20), (int)(massB/20));
			g.drawString(""+(int) massA, (int)(310 + (collision * velocA) + (time * vfa)), (150));
			g.setColor(Color.BLUE);
			g.drawString(""+(int) massB, (int)((690- collision * velocB) - (time * vfb)),150);
			g.drawString("Final Velocity of Cart 1: "+vfat, 250, 250);
			g.drawString("Final Velocity of Cart 2: "+(-vfbt), 250, 300);
		}
		if (collide == true && running == false)
		{
			g.setColor(Color.BLUE);
			g.drawLine((int)(20+time2*20), (int)(500-velocA), (int) (20+time2*20), (int)(500 - vfa));
			g.drawLine(20,(int) (500-velocA),(int)(20+time2*20),(int)(500-velocA));
			g.drawLine((int) (20+time2*20), (int)(500 - vfa), (int)(20 + (time2 + time) * 20), (int)(500 - vfa));
			g.setColor(Color.RED);
			g.drawLine((int)(20+time2*20), (int)(500+velocB), (int) (20+time2*20), (int)(500 + vfb));
			g.drawLine(20,(int) (500+velocB),(int)(20+time2*20),(int)(500+velocB));
			g.drawLine((int) (20+time2*20), (int)(500 + vfb), (int)(20 + (time2 + time) * 20), (int)(500 + vfb));
			System.out.println(time);
			g.setColor(Color.BLUE);
			g.fillOval((int)((300 + collision * velocA) + (time * vfa)), (int)(150 - (massA/40)), (int)(massA/20), (int)(massA/20));
			g.fillOval((int)((700 - collision * velocB) - (time * vfb)), (int)(150 - (massB/40)), (int)(massB/20), (int)(massB/20));
			g.drawString("Final Velocity of Cart 1: "+vfat, 250, 250);
			g.drawString("Final Velocity of Cart 2: "+(-vfbt), 250, 300);
		}
		if(running == true)
		{running();}
	}

	public void running()
	{
		time = time + .1;
		if (time >= collision && collide == false)
		{
			collide = true;
			time2 = time;
			time = 0;
		}
		if(collide==true&&time+time2>65){
			running=false;
		}
		try
		{
			Thread.sleep(20);
		}
		catch (Exception e)
		{
		}
		repaint();
	}

	public class buttonMenu implements ActionListener
	{
		private int value;

		public buttonMenu(int a)
		{
			value = a;
		}

		public void actionPerformed(ActionEvent arg0)
		{

			if (value == 0)
			{
				running = true;
				try
				{
					massA = Double.parseDouble(mass1.getText());
					massB = Double.parseDouble(mass2.getText());
					velocA = Double.parseDouble(veloc1.getText());
					velocB = Double.parseDouble(veloc2.getText());
					if (massA < 500)
						massA = 500;
					if (massA > 2000)
						massA = 2000;
					if (massB < 500)
						massB = 500;
					if (massB > 2000)
						massB = 2000;
					if (velocA < 0)
						velocA = 0;
					if (velocA > 25)
						velocA = 25;
					if (velocB < 0)
						velocB = 0;
					if (velocB > 25)
						velocB = 25;
				}
				catch (Exception e)
				{
					running = false;
				}
				collision = ((400 - (massA/20)) / ((velocA + velocB)));
				vfa = (((massA - massB) / (massA + massB)) * velocA + ((2 * massB) / (massA + massB)) * (-velocB));
				vfb = -(((massB - massA) / (massA + massB)) * (-velocB) + ((2 * massA) / (massA + massB)) * velocA);
				long x=(long)(vfa*100);
				vfat=(double)x/100;
				long y=(long)(vfb*100);
				vfbt=(double)y/100;
			}
			if (value == 1)
			{
				running = false;
				restart = true;
				time = 0;
				time2=0;
				collide = false;
			}
			repaint();
		}
	}
}

