package phyApps.common;

import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

@SuppressWarnings("serial")
public class ControllerViewLayout extends GridBagLayout {
	
	public ControllerViewLayout() {
		super();
	}
	
	public void addController(Component controller) {
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.FIRST_LINE_START;
		this.addLayoutComponent(controller, constraints);
	}
	
	public void addView(Component view) {
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.fill = GridBagConstraints.BOTH;
		this.addLayoutComponent(view, constraints);
	}
}
