package phyApps.common.graph;

import java.awt.Color;
import java.awt.Graphics;
import java.util.Iterator;


/*
 * A sequence of connected points.
 */
public class CurvePlot extends ScatterPlot {
	
	public CurvePlot(Graph graph, Color color) {
		super(graph, color);
	}
	
	public void draw(Graphics g) {
		Iterator<Point> iter = points.iterator();
		if (iter.hasNext()) {
			Point start = iter.next();
			while (iter.hasNext()) {
				Point end = iter.next();
				graph.drawLine(g, start, end, color);
				start = end;
			}
		}
	}
}