/*
 * Created by JFormDesigner on Wed Dec 02 12:12:56 EST 2009
 */

package WebBuilder;

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.sql.SQLException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

import javax.swing.*;
import com.jgoodies.forms.factories.*;
import com.jgoodies.forms.layout.*;

/**
 * @author Someone
 */
public class Courseframe extends JFrame {
	int c_id ;
	int lecturer_id = -1;
	int coordinator_id = -1;
	int lab_coordinator_id = -1;
	WebpageDB webDB = null;
	String[][] LecturerListArray;
	String[][] CoordinatorListArray;
	String[][] LabCoordinatorListArray;
	String[][] LabListArray;
	String[][] SectionListArray;
	
	public Courseframe(WebpageDB db, int course_id) {
		webDB = db;
		c_id = course_id;
		initComponents();
		
		if( c_id!=-1) {
			try {
				//"CREATE TABLE course( ID INTEGER IDENTITY, title VARCHAR(256), year VARCHAR(2),
				//department VARCHAR(2), course_number INTEGER, start_date DATE, end_date DATE, 
				//lecturer_id INTEGER, coordinator_id INTEGER, lab_coordinator_id INTEGER)");
				String title = webDB.query_single("select title from course where ID = " + c_id).toString();
				String year = webDB.query_single("select year from course where ID = " + c_id).toString();
				String department = webDB.query_single("select department from course where ID = " + c_id).toString();
				String term = webDB.query_single("select term from course where ID = " + c_id).toString();
				String course_number = webDB.query_single("select course_number from course where ID = " + c_id).toString();
				String start_date = webDB.query_single("select start_date from course where ID = " + c_id).toString();
				String end_date = webDB.query_single("select end_date from course where ID = " + c_id).toString();
				String lect_id = webDB.query_single("select lecturer_id from course where ID = " + c_id).toString();
				Object objcoord_id= webDB.query_single("select coordinator_id from course where ID = " + c_id);
				if (objcoord_id!=null) {
					String coord_id = objcoord_id.toString();
					coordinator_id = Integer.parseInt(coord_id);
					String coordinator_name = webDB.query_single("select coordinator_name from coordinator where ID = " + coordinator_id).toString();
					CoordinatorDisplayField.setText(coordinator_name);
				}
				String lab_coord_id = webDB.query_single("select lab_coordinator_id from course where ID = " + c_id).toString();
				lecturer_id = Integer.parseInt(lect_id);
				lab_coordinator_id = Integer.parseInt(lab_coord_id);


				String lecturer_name = webDB.query_single("select lecturer_name from lecturer where ID = " + lecturer_id).toString();
				LecturerDisplayField.setText(lecturer_name);
				String lab_coordinator_name = webDB.query_single("select lab_coordinator_name from lab_coordinator where ID = " + lab_coordinator_id).toString();
				LabCoordinatorDisplayField.setText(lab_coordinator_name);
				
				CourseTitleField.setText(title);
				AcademicYearField.setText(year);
				TermComboBox.setSelectedItem(term);
				DepartmentField.setText(department);
				CourseNumberField.setText(course_number);
				StartDateField.setText(start_date);
				EndDateField.setText(end_date);
				
				
    			CourseNumberField.setEnabled(true);
    			CourseNumberLabel.setEnabled(true);
    			DepartmentField.setEnabled(true);
    			DepartmentLabel.setEnabled(true);
				TermLabel.setEnabled(true);
				TermComboBox.setEnabled(true);    			
				AcademicYearLabel.setEnabled(true);
				AcademicYearField.setEnabled(true);
				
				//LecturerLabel.setEnabled(true);
				//LecturerField.setEnabled(true);
				StartDateLabel.setEnabled(true);
				StartDateField.setEnabled(true);
				EndDateLabel.setEnabled(true);
				EndDateField.setEnabled(true);

				LecturerLabel.setEnabled(true);
				LecturerDisplayField.setEnabled(true);
				SelectLecturerButton.setEnabled(true);
				AddLecturerButton.setEnabled(true);
				ModifyLecturerButton.setEnabled(true);
				RemoveLecturerButton.setEnabled(true);
				LecturerList.setEnabled(true);

				CoordinatorLabel.setEnabled(true);
				CoordinatorDisplayField.setEnabled(true);
				SelectCoordinatorButton.setEnabled(true);
				AddCoordinatorButton.setEnabled(true);
				ModifyCoordinatorButton.setEnabled(true);
				RemoveCoordinatorButton.setEnabled(true);
				CoordinatorList.setEnabled(true);
				
				LabCoordinatorLabel.setEnabled(true);
				LabCoordinatorDisplayField.setEnabled(true);
				SelectLabCoordinatorButton.setEnabled(true);
				AddLabCoordinatorButton.setEnabled(true);
				ModifyLabCoordinatorButton.setEnabled(true);
				RemoveLabCoordinatorButton.setEnabled(true);
				LabCoordinatorList.setEnabled(true);
				
				ModifySectionButton.setEnabled(true);
				AddSectionButton.setEnabled(true);
				RemoveSectionButton.setEnabled(true);
				ModifyLabButton.setEnabled(true);
				AddLabButton.setEnabled(true);
				RemoveLabButton.setEnabled(true);
				LabList.setEnabled(true);
				SectionList.setEnabled(true);
				LabLabel.setEnabled(true);
				SectionLabel.setEnabled(true);
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}	
			
		}
		LecturerList.setListData(getLecturerList(webDB));
		CoordinatorList.setListData(getCoordinatorList(webDB));
		LabCoordinatorList.setListData(getLabCoordinatorList(webDB));
		LabList.setListData(getLabList(webDB));
		SectionList.setListData(getSectionList(webDB));
	}

	  private String[] getLecturerList(WebpageDB db) {
			String[] returnString = new String[]{"a", "b"};
			Integer page_count;
			
			try {			
				page_count = Integer.valueOf(db.query_single("select count(ID) from lecturer").toString());
				if (page_count > 0) {					
					String[][] lecturers = db.query_array("select ID, lecturer_name FROM lecturer");
					LecturerListArray = lecturers;
					ArrayList<String> titles = new ArrayList<String>();

					for (int i = 0; i <lecturers.length;i++ ){
						System.out.print(lecturers[i][0] + "\n");
						System.out.print(lecturers[i][1] + "\n");
						titles.add("[" + lecturers[i][0] + "] " + lecturers[i][1]);
					}
					Object[] ObjArray =  titles.toArray();
					
					returnString = new String[ObjArray.length];
					for (int j = 0 ; j<ObjArray.length;j++){
						returnString[j] = ObjArray[j].toString();
					}
				} else {
					returnString = new String[]{};
				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return returnString;
		}		  
	  private String[] getCoordinatorList(WebpageDB db) {
			String[] returnString = new String[]{"a", "b"};
			Integer page_count;
			
			try {			
				page_count = Integer.valueOf(db.query_single("select count(ID) from coordinator").toString());
				if (page_count > 0) {					
					String[][] coordinators = db.query_array("select ID, coordinator_name FROM coordinator");
					CoordinatorListArray = coordinators;
					ArrayList<String> titles = new ArrayList<String>();

					for (int i = 0; i <coordinators.length;i++ ){
						System.out.print(coordinators[i][0] + "\n");
						System.out.print(coordinators[i][1] + "\n");
						titles.add("[" + coordinators[i][0] + "] " + coordinators[i][1]);
					}
					Object[] ObjArray =  titles.toArray();
					
					returnString = new String[ObjArray.length];
					for (int j = 0 ; j<ObjArray.length;j++){
						returnString[j] = ObjArray[j].toString();
					}
				} else {
					returnString = new String[]{};
				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return returnString;
		}		  
	  
	  
	  private String[] getLabCoordinatorList(WebpageDB db) {
			String[] returnString = new String[]{"a", "b"};
			Integer page_count;
			
			try {			
				page_count = Integer.valueOf(db.query_single("select count(ID) from lab_coordinator").toString());
				if (page_count > 0) {					
					String[][] labcoordinators = db.query_array("select ID, lab_coordinator_name FROM lab_coordinator");
					LabCoordinatorListArray = labcoordinators;
					ArrayList<String> titles = new ArrayList<String>();

					for (int i = 0; i <labcoordinators.length;i++ ){
						System.out.print(labcoordinators[i][0] + "\n");
						System.out.print(labcoordinators[i][1] + "\n");
						titles.add("[" + labcoordinators[i][0] + "] " + labcoordinators[i][1]);
					}
					Object[] ObjArray =  titles.toArray();
					
					returnString = new String[ObjArray.length];
					for (int j = 0 ; j<ObjArray.length;j++){
						returnString[j] = ObjArray[j].toString();
					}
				} else {
					returnString = new String[]{};
				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return returnString;
		}	
	  private String[] getLabList(WebpageDB db) {
			String[] returnString = new String[]{"a", "b"};
			Integer page_count;
			
			try {			
				page_count = Integer.valueOf(db.query_single("select count(ID) from lab where courseID = " + c_id).toString());
				if (page_count > 0) {					
					String[][] labs = db.query_array("select ID, title FROM lab where courseID = " + c_id);
					LabListArray = labs;
					ArrayList<String> titles = new ArrayList<String>();

					for (int i = 0; i <labs.length;i++ ){
						System.out.print(labs[i][0] + "\n");
						System.out.print(labs[i][1] + "\n");
						titles.add("[" + labs[i][0] + "] " + labs[i][1]);
					}
					Object[] ObjArray =  titles.toArray();
					
					returnString = new String[ObjArray.length];
					for (int j = 0 ; j<ObjArray.length;j++){
						returnString[j] = ObjArray[j].toString();
					}
				} else {
					returnString = new String[]{};
				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return returnString;
		}		 
	  private String[] getSectionList(WebpageDB db) {
			String[] returnString = new String[]{"a", "b"};
			Integer page_count;
			
			try {			
				page_count = Integer.valueOf(db.query_single("select count(ID) from section where courseID = " + c_id).toString());
				if (page_count > 0) {					
					String[][] sections = db.query_array("select ID, section_number FROM section where courseID = " + c_id);
					SectionListArray = sections;
					ArrayList<String> titles = new ArrayList<String>();

					for (int i = 0; i <sections.length;i++ ){
						System.out.print(sections[i][0] + "\n");
						System.out.print(sections[i][1] + "\n");
						titles.add("[" + sections[i][0] + "] " + sections[i][1]);
					}
					Object[] ObjArray =  titles.toArray();
					
					returnString = new String[ObjArray.length];
					for (int j = 0 ; j<ObjArray.length;j++){
						returnString[j] = ObjArray[j].toString();
					}
				} else {
					returnString = new String[]{};
				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			return returnString;
		}			  
	private void CourseTitleFieldActionPerformed(ActionEvent e) {
		if (!CourseTitleField.getText().isEmpty()) {
			if (c_id == -1) { 


				int max_page_order;
    			try {
    				
    				webDB.update("INSERT INTO course(title) VALUES('" + CourseTitleField.getText() + "')");
    				c_id = Integer.valueOf(webDB.query_single("select max(ID) from course").toString());
    				
    			} catch (SQLException e1) {
    				// TODO Auto-generated catch block
    				e1.printStackTrace();
    			}				
    			CourseNumberField.setEnabled(true);
    			CourseNumberLabel.setEnabled(true);
    			DepartmentField.setEnabled(true);
    			DepartmentLabel.setEnabled(true);
				TermLabel.setEnabled(true);
				TermComboBox.setEnabled(true);    			
				AcademicYearLabel.setEnabled(true);
				AcademicYearField.setEnabled(true);
				
				//LecturerLabel.setEnabled(true);
				//LecturerField.setEnabled(true);
				StartDateLabel.setEnabled(true);
				StartDateField.setEnabled(true);
				EndDateLabel.setEnabled(true);
				EndDateField.setEnabled(true);

				LecturerLabel.setEnabled(true);
				LecturerDisplayField.setEnabled(true);
				SelectLecturerButton.setEnabled(true);
				AddLecturerButton.setEnabled(true);
				ModifyLecturerButton.setEnabled(true);
				RemoveLecturerButton.setEnabled(true);
				LecturerList.setEnabled(true);

				CoordinatorLabel.setEnabled(true);
				CoordinatorDisplayField.setEnabled(true);
				SelectCoordinatorButton.setEnabled(true);
				AddCoordinatorButton.setEnabled(true);
				ModifyCoordinatorButton.setEnabled(true);
				RemoveCoordinatorButton.setEnabled(true);
				CoordinatorList.setEnabled(true);
				
				LabCoordinatorLabel.setEnabled(true);
				LabCoordinatorDisplayField.setEnabled(true);
				SelectLabCoordinatorButton.setEnabled(true);
				AddLabCoordinatorButton.setEnabled(true);
				ModifyLabCoordinatorButton.setEnabled(true);
				RemoveLabCoordinatorButton.setEnabled(true);
				LabCoordinatorList.setEnabled(true);
				
				ModifySectionButton.setEnabled(true);
				AddSectionButton.setEnabled(true);
				RemoveSectionButton.setEnabled(true);
				ModifyLabButton.setEnabled(true);
				AddLabButton.setEnabled(true);
				RemoveLabButton.setEnabled(true);
				LabList.setEnabled(true);
				SectionList.setEnabled(true);
				LabLabel.setEnabled(true);
				SectionLabel.setEnabled(true);
				
				LecturerList.setListData(getLecturerList(webDB));
				CoordinatorList.setListData(getCoordinatorList(webDB));
				LabCoordinatorList.setListData(getLabCoordinatorList(webDB));
				LabList.setListData(getLabList(webDB));
				SectionList.setListData(getSectionList(webDB));
			}
		} else {
			Interface.ShowMessgaeBox("enter a title for the page to proceed");
			
		}
		
		
	}

	private Boolean CheckCourseData() {
		Boolean success= true;
		if (DepartmentField.getText().isEmpty()) {
			Interface.ShowMessgaeBox("enter a department code to proceed");
			success = false;
		}
		if (CourseNumberField.getText().isEmpty()) {
			Interface.ShowMessgaeBox("enter a course number to proceed");
			success = false;
		} 
		
		if (AcademicYearField.getText().isEmpty()) {
			Interface.ShowMessgaeBox("enter an academic year to proceed");
			success = false;
		} else {
			//check that this is a 2 digit number
			if (AcademicYearField.getText().length()!=2) {
				Interface.ShowMessgaeBox("enter the academic year as a 2 digit number");
				success = false;				
			} else {
				try {
					Integer.parseInt(AcademicYearField.getText());
				} catch (NumberFormatException nfe) {
					Interface.ShowMessgaeBox("enter the academic year as a 2 digit number");
					success = false;
				}
			}
		}
		
		if (StartDateField.getText().isEmpty()) {
			Interface.ShowMessgaeBox("enter a start date to proceed");
			success = false;
		} else {
			SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		    Date testDate = null;
		    try
		    {
		      testDate = sdf.parse(StartDateField.getText());
		    }
		    catch (ParseException e)
		    {
				Interface.ShowMessgaeBox("please enter the start date in the YYYY-MM-DD format");
				success = false;
		    }

		}
		if (EndDateField.getText().isEmpty()) {
			Interface.ShowMessgaeBox("enter an end date to proceed");
			success = false;
		} else {
			//also check the formatting of the date fields
			SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		    Date testDate = null;
		    try
		    {
		      testDate = sdf.parse(EndDateField.getText());
		    }
		    catch (ParseException e)
		    {
				Interface.ShowMessgaeBox("please enter the end date in the YYYY-MM-DD format");
				success = false;
		    }
		}
		if (lecturer_id<0) {
			Interface.ShowMessgaeBox("select a lecturer from the list");
			success = false;			
		}
// we are going to allow the coordinator not to be entered if not needed		
//		if (coordinator_id<0) {
//			Interface.ShowMessgaeBox("select a coordinator from the list");
//			success = false;			
//		}
		if (lab_coordinator_id<0) {
			Interface.ShowMessgaeBox("select a lab coordinator from the list");
			success = false;			
		}		
		
		return success;
		
	}
	
	private void SaveButtonActionPerformed(ActionEvent e) {
		Boolean success= false;
		
    	if (!CourseTitleField.getText().isEmpty()) {
    		if (CheckCourseData()) {
				try {
					//"CREATE TABLE course( ID INTEGER IDENTITY, title VARCHAR(256), year VARCHAR(2),
					//department VARCHAR(2), course_number INTEGER, start_date DATE, end_date DATE, 
					//lecturer_id INTEGER, coordinator_id INTEGER, lab_coordinator_id INTEGER)");
					
					//department, course_number, start_date, end_date, 
					//lecturer_id, coordinator_id, lab_coordinator_id
					
					//to allow the coordinator to be optional
					String data = "";
					if (coordinator_id>=0 ) {
						data += ", coordinator_id= " + coordinator_id;
					}
					
					webDB.update("UPDATE course SET title = '" + CourseTitleField.getText() + "', year = '" + AcademicYearField.getText() + "', term = '" + TermComboBox.getSelectedItem() + "', department = '" + DepartmentField.getText() + "', course_number = '" + CourseNumberField.getText() + "', start_date = '" + StartDateField.getText() + "', end_date = '" + EndDateField.getText() + "', lecturer_id = " + lecturer_id + data + ", lab_coordinator_id = " + lab_coordinator_id + " where ID = " + c_id);
					success = true;
				} catch (SQLException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
    		}
		} else {
			Interface.ShowMessgaeBox("enter a title  to proceed");
		}		
    	
		if (success) {
			this.setVisible(false);
			this.dispose();
		}
		
		
	}

	private void cancelButtonActionPerformed(ActionEvent e) {
		// TODO add your code here
		this.setVisible(false);
		this.dispose();
	}

	private void AddLecturerButtonActionPerformed(ActionEvent e) {
		Lecturerframe add_Lecturerframe = new Lecturerframe(webDB, -1);
		add_Lecturerframe.show();	
	}

	private void AddCoordinatorButtonActionPerformed(ActionEvent e) {
		Coordinatorframe add_Coordinatorframe = new Coordinatorframe(webDB, -1);
		add_Coordinatorframe.show();	
	}

	private void AddLabCoordinatorButtonActionPerformed(ActionEvent e) {
		LabCoordinatorframe add_LabCoordinatorframe = new LabCoordinatorframe(webDB, -1);
		add_LabCoordinatorframe.show();	
	}

	private void AddSectionButtonActionPerformed(ActionEvent e) {
		Sectionframe add_Sectionframe = new Sectionframe(webDB, -1,c_id);
		add_Sectionframe.show();	
	}

	private void AddLabButtonActionPerformed(ActionEvent e) {
		Labframe add_Labframe = new Labframe(webDB, -1, c_id);
		add_Labframe.show();	
	}

	private void SelectLecturerButtonActionPerformed(ActionEvent e) {
		  if (LecturerList.isSelectionEmpty()) {
			  Interface.ShowMessgaeBox("Select a lecturer to assign to the course");
			  return;
			  
		  } else {
			  int lect_id = Integer.valueOf(LecturerListArray[LecturerList.getSelectedIndex()][0]);
			  lecturer_id = lect_id;
		  }
		  LecturerDisplayField.setText(LecturerListArray[LecturerList.getSelectedIndex()][1]);
	}

	private void SelectCoordinatorButtonActionPerformed(ActionEvent e) {
		  if (CoordinatorList.isSelectionEmpty()) {
			  Interface.ShowMessgaeBox("Select a coordinator to assign to the course");
			  return;
			  
		  } else {
			  int coord_id = Integer.valueOf(CoordinatorListArray[CoordinatorList.getSelectedIndex()][0]);
			  coordinator_id = coord_id;
		  }
		  CoordinatorDisplayField.setText(CoordinatorListArray[CoordinatorList.getSelectedIndex()][1]);
	}

	private void SelectLabCoordinatorButtonActionPerformed(ActionEvent e) {
		  if (LabCoordinatorList.isSelectionEmpty()) {
			  Interface.ShowMessgaeBox("Select a lab coordinator to assign to the course");
			  return;
			  
		  } else {
			  int lab_coord_id = Integer.valueOf(LabCoordinatorListArray[LabCoordinatorList.getSelectedIndex()][0]);
			  lab_coordinator_id = lab_coord_id;
		  }
		  LabCoordinatorDisplayField.setText(LabCoordinatorListArray[LabCoordinatorList.getSelectedIndex()][1]);
	}

	private void thisWindowGainedFocus(WindowEvent e) {
		LecturerList.setListData(getLecturerList(webDB));
		CoordinatorList.setListData(getCoordinatorList(webDB));
		LabCoordinatorList.setListData(getLabCoordinatorList(webDB));
		LabList.setListData(getLabList(webDB));
		SectionList.setListData(getSectionList(webDB));
		if (!LecturerList.isSelectionEmpty()) {
			LecturerDisplayField.setText(LecturerListArray[LecturerList.getSelectedIndex()][1]);
		}
		if (!CoordinatorList.isSelectionEmpty()) {
			CoordinatorDisplayField.setText(CoordinatorListArray[CoordinatorList.getSelectedIndex()][1]);
		}
		if (!LabCoordinatorList.isSelectionEmpty()) {
			LabCoordinatorDisplayField.setText(LabCoordinatorListArray[LabCoordinatorList.getSelectedIndex()][1]);
		}
	}

	private void ModifyLecturerButtonActionPerformed(ActionEvent e) {
		if (LecturerList.isSelectionEmpty()){
			Interface.ShowMessgaeBox("you must select an item from the lecturer list to be modified");
			
		} else {
			int lecturer_toMod = LecturerList.getSelectedIndex();
			int lecturer_toMod_ID = Integer.valueOf(LecturerListArray[lecturer_toMod][0]);
			Lecturerframe mod_Lecturerframe = new Lecturerframe(webDB, lecturer_toMod_ID);
			mod_Lecturerframe.show();		
		}
	}

	private void ModifyCoordinatorButtonActionPerformed(ActionEvent e) {
		if (CoordinatorList.isSelectionEmpty()){
			Interface.ShowMessgaeBox("you must select an item from the coordinator list to be modified");
			
		} else {
			int coordinator_toMod = CoordinatorList.getSelectedIndex();
			int coordinator_toMod_ID = Integer.valueOf(CoordinatorListArray[coordinator_toMod][0]);
			Coordinatorframe mod_Coordinatorframe = new Coordinatorframe(webDB, coordinator_toMod_ID);
			mod_Coordinatorframe.show();		
		}
	}

	private void ModifyLabCoordinatorButtonActionPerformed(ActionEvent e) {
		if (LabCoordinatorList.isSelectionEmpty()){
			Interface.ShowMessgaeBox("you must select an item from the lab coordinator list to be modified");
			
		} else {
			int lab_coordinator_toMod = LabCoordinatorList.getSelectedIndex();
			int lab_coordinator_toMod_ID = Integer.valueOf(LabCoordinatorListArray[lab_coordinator_toMod][0]);
			LabCoordinatorframe mod_LabCoordinatorframe = new LabCoordinatorframe(webDB, lab_coordinator_toMod_ID);
			mod_LabCoordinatorframe.show();		
		}
	}

	private void RemoveLecturerButtonActionPerformed(ActionEvent e) {
		if (LecturerList.isSelectionEmpty()){
			Interface.ShowMessgaeBox("you must select an item from the lecturer list to be removed");
		} else {
			int lect_used_count;
			try {
				int lecturer_toRemove = LecturerList.getSelectedIndex();
				int lecturer_toRemove_ID = Integer.valueOf(LecturerListArray[lecturer_toRemove][0]);
				
				lect_used_count = Integer.valueOf(webDB.query_single("select count(ID) from course where lecturer_id = " + lecturer_toRemove_ID + " and ID != " + c_id).toString());
				if (lect_used_count >0 ) {
					Interface.ShowMessgaeBox("the lecturer cannot be removed because they are being used in another course");
				} else {
					webDB.update("DELETE FROM lecturer where id = " + lecturer_toRemove_ID);
				}
			} catch (NumberFormatException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			LecturerList.setListData(getLecturerList(webDB));
		}
	}

	private void RemoveCoordinatorButtonActionPerformed(ActionEvent e) {
		if (CoordinatorList.isSelectionEmpty()){
			Interface.ShowMessgaeBox("you must select an item from the coordinator list to be removed");
		} else {
			int coord_used_count;
			try {
				int coordinator_toRemove = CoordinatorList.getSelectedIndex();
				int coordinator_toRemove_ID = Integer.valueOf(CoordinatorListArray[coordinator_toRemove][0]);
				
				coord_used_count = Integer.valueOf(webDB.query_single("select count(ID) from course where coordinator_id = " + coordinator_toRemove_ID + " and ID != " + c_id).toString());
				if (coord_used_count >0 ) {
					Interface.ShowMessgaeBox("the coordinator cannot be removed because they are being used in another course");
				} else {
					webDB.update("DELETE FROM coordinator where id = " + coordinator_toRemove_ID);
				}
			} catch (NumberFormatException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			CoordinatorList.setListData(getCoordinatorList(webDB));
//			LabCoordinatorList.setListData(getLabCoordinatorList(webDB));
		}
	}

	private void RemoveLabCoordinatorButtonActionPerformed(ActionEvent e) {
		if (LabCoordinatorList.isSelectionEmpty()){
			Interface.ShowMessgaeBox("you must select an item from the lab coordinator list to be removed");
		} else {
			int lab_coord_used_count;
			try {
				int lab_coordinator_toRemove = LabCoordinatorList.getSelectedIndex();
				int lab_coordinator_toRemove_ID = Integer.valueOf(LabCoordinatorListArray[lab_coordinator_toRemove][0]);
				
				lab_coord_used_count = Integer.valueOf(webDB.query_single("select count(ID) from course where lab_coordinator_id = " + lab_coordinator_toRemove_ID + " and ID != " + c_id).toString());
				if (lab_coord_used_count >0 ) {
					Interface.ShowMessgaeBox("the lab coordinator cannot be removed because they are being used in another course");
				} else {
					webDB.update("DELETE FROM lab_coordinator where id = " + lab_coordinator_toRemove_ID);
				}
			} catch (NumberFormatException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			LabCoordinatorList.setListData(getLabCoordinatorList(webDB));
		}
		
	}

	private void ModifyLabButtonActionPerformed(ActionEvent e) {
		if (LabList.isSelectionEmpty()){
			Interface.ShowMessgaeBox("you must select an item from the lab list to be modified");
			
		} else {
			int lab_toMod = LabList.getSelectedIndex();
			int lab_toMod_ID = Integer.valueOf(LabListArray[lab_toMod][0]);
			Labframe mod_Labframe = new Labframe(webDB, lab_toMod_ID, c_id);
			mod_Labframe.show();		
		}
	}

	private void ModifySectionButtonActionPerformed(ActionEvent e) {
		if (SectionList.isSelectionEmpty()){
			Interface.ShowMessgaeBox("you must select an item from the section list to be modified");
			
		} else {
			int section_toMod = SectionList.getSelectedIndex();
			int section_toMod_ID = Integer.valueOf(SectionListArray[section_toMod][0]);
			Sectionframe mod_Sectionframe = new Sectionframe(webDB, section_toMod_ID, c_id);
			mod_Sectionframe.show();		
		}
	}

	private void RemoveLabButtonActionPerformed(ActionEvent e) {
		// TODO add your code here
		if (LabList.isSelectionEmpty()){
			Interface.ShowMessgaeBox("you must select an item from the lab list to be removed");
			
		} else {
			int lab_toRemove = LabList.getSelectedIndex();
			int lab_toRemove_ID = Integer.valueOf(LabListArray[lab_toRemove][0]);
			try {
				//remove the lab document
				int lab_doc_Count = Integer.valueOf(webDB.query_single("Select count(ID) From lab_document where lab_id = " + lab_toRemove_ID).toString());
				
				if (lab_doc_Count>0){
					String[][] elements_toremove = webDB.query_array("select ID FROM lab_document where lab_id= " + lab_toRemove_ID);
	
					for (int i = 0; i <elements_toremove.length;i++ ){
						int doc_toRemove_ID = Integer.valueOf(elements_toremove[i][0]);
						
						//			//"CREATE TABLE lab_document( ID INTEGER IDENTITY, lab_id INTEGER, title VARCHAR(256), doc_type VARCHAR(5), external_URL VARCHAR(256), document_id INTEGER)");
						String doctype = webDB.query_single("Select doc_type From lab_document WHERE ID = " + doc_toRemove_ID).toString();
			
						if (doctype.equals("FILE")) {
							////////////////////////////
							//
							//	Remove the file
							//
							int document_id = Integer.parseInt(webDB.query_single("Select document_id From lab_document WHERE ID = " + doc_toRemove_ID).toString());
							String fileName = null;
			
								fileName = webDB.query_single("Select filename From document WHERE ID = " + document_id).toString();
							
						    // A File object to represent the filename
						    File f = new File("./" + webDB.DB_NAME + "/" + fileName);
						    // Make sure the file or directory exists and isn't write protected
						    if (!f.exists())
						      throw new IllegalArgumentException(
						          "Delete: no such file or directory: " + fileName);
						    if (!f.canWrite())
						      throw new IllegalArgumentException("Delete: write protected: "
						          + fileName);
						    // Attempt to delete it
						    boolean success = f.delete();
						    if (!success)
						      throw new IllegalArgumentException("Delete: deletion failed");
						    
							webDB.update("Delete From document WHERE ID = " + document_id);
			
						}
					    ////////////////////////////////////
					    //
					    //	Delete the row from the database
					    //
					    //
						webDB.update("Delete From lab_document WHERE ID = " + doc_toRemove_ID);
					}
				}
			//remove from ref_section_lab where labid = labID
			webDB.update("Delete From ref_section_lab WHERE labID = " + lab_toRemove_ID);
			//REMOVE THE row from lab
			webDB.update("Delete From lab WHERE ID = " + lab_toRemove_ID);	
				
				
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		String[] Labs =  getLabList(webDB);
		LabList.setListData(Labs);
	}

	private void RemoveSectionButtonActionPerformed(ActionEvent e) {
		if (SectionList.isSelectionEmpty()){
			Interface.ShowMessgaeBox("you must select an item from the section list to be removed");
			
		} else {
			int section_toRemove = SectionList.getSelectedIndex();
			int section_toRemove_ID = Integer.valueOf(SectionListArray[section_toRemove][0]);
			try {
			
				webDB.update("Delete From ref_section_lab WHERE sectionID = " + section_toRemove_ID);
				//REMOVE THE row from lab
				webDB.update("Delete From section WHERE ID = " + section_toRemove_ID);
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		String[] Sections =  getSectionList(webDB);
		SectionList.setListData(Sections);
	}


	private void initComponents() {
		// JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents
		dialogPane = new JPanel();
		contentPanel = new JPanel();
		label1 = new JLabel();
		CourseTitleField = new JTextField();
		CourseNumberLabel = new JLabel();
		CourseNumberField = new JTextField();
		DepartmentLabel = new JLabel();
		DepartmentField = new JTextField();
		AcademicYearLabel = new JLabel();
		AcademicYearField = new JTextField();
		TermLabel = new JLabel();
		TermComboBox = new JComboBox();
		StartDateLabel = new JLabel();
		StartDateField = new JTextField();
		EndDateLabel = new JLabel();
		EndDateField = new JTextField();
		LecturerLabel = new JLabel();
		LecturerDisplayField = new JTextField();
		CoordinatorLabel = new JLabel();
		CoordinatorDisplayField = new JTextField();
		LabCoordinatorLabel = new JLabel();
		LabCoordinatorDisplayField = new JTextField();
		SelectLecturerButton = new JButton();
		AddLecturerButton = new JButton();
		ModifyLecturerButton = new JButton();
		RemoveLecturerButton = new JButton();
		SelectCoordinatorButton = new JButton();
		AddCoordinatorButton = new JButton();
		ModifyCoordinatorButton = new JButton();
		RemoveCoordinatorButton = new JButton();
		SelectLabCoordinatorButton = new JButton();
		AddLabCoordinatorButton = new JButton();
		ModifyLabCoordinatorButton = new JButton();
		RemoveLabCoordinatorButton = new JButton();
		scrollPane3 = new JScrollPane();
		LecturerList = new JList();
		scrollPane4 = new JScrollPane();
		CoordinatorList = new JList();
		scrollPane5 = new JScrollPane();
		LabCoordinatorList = new JList();
		LabLabel = new JLabel();
		AddLabButton = new JButton();
		ModifyLabButton = new JButton();
		RemoveLabButton = new JButton();
		SectionLabel = new JLabel();
		AddSectionButton = new JButton();
		ModifySectionButton = new JButton();
		RemoveSectionButton = new JButton();
		scrollPane1 = new JScrollPane();
		LabList = new JList();
		scrollPane2 = new JScrollPane();
		SectionList = new JList();
		buttonBar = new JPanel();
		SaveButton = new JButton();
		cancelButton = new JButton();
		CellConstraints cc = new CellConstraints();

		//======== this ========
		setTitle("Course");
		addWindowFocusListener(new WindowAdapter() {
			@Override
			public void windowGainedFocus(WindowEvent e) {
				thisWindowGainedFocus(e);
			}
		});
		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout());

		//======== dialogPane ========
		{
			dialogPane.setBorder(Borders.DIALOG_BORDER);
			dialogPane.setLayout(new BorderLayout());

			//======== contentPanel ========
			{
				contentPanel.setLayout(new FormLayout(
					"53dlu, $lcgap, 13dlu, $lcgap, 29dlu, $lcgap, 31dlu, 2*($lcgap, default), $lcgap, 23dlu, $lcgap, 16dlu, $lcgap, 13dlu, $lcgap, 31dlu, 4*($lcgap, default), $lcgap, 42dlu, $lcgap, 9dlu, $lcgap, 30dlu, 3*($lcgap, default)",
					"7*(default, $lgap), 37dlu, 3*($lgap, default), $lgap, 91dlu, $lgap, default"));

				//---- label1 ----
				label1.setText("Title");
				label1.setHorizontalAlignment(SwingConstants.CENTER);
				contentPanel.add(label1, cc.xy(1, 1));

				//---- CourseTitleField ----
				CourseTitleField.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						CourseTitleFieldActionPerformed(e);
					}
				});
				contentPanel.add(CourseTitleField, cc.xywh(3, 1, 9, 1));

				//---- CourseNumberLabel ----
				CourseNumberLabel.setText("Course Number");
				CourseNumberLabel.setEnabled(false);
				contentPanel.add(CourseNumberLabel, cc.xy(1, 3));

				//---- CourseNumberField ----
				CourseNumberField.setEnabled(false);
				contentPanel.add(CourseNumberField, cc.xywh(3, 3, 4, 1));

				//---- DepartmentLabel ----
				DepartmentLabel.setText("Department Code (PH)");
				DepartmentLabel.setHorizontalAlignment(SwingConstants.CENTER);
				DepartmentLabel.setEnabled(false);
				contentPanel.add(DepartmentLabel, cc.xywh(9, 3, 7, 1));

				//---- DepartmentField ----
				DepartmentField.setEnabled(false);
				DepartmentField.setText("PH");
				contentPanel.add(DepartmentField, cc.xy(17, 3));

				//---- AcademicYearLabel ----
				AcademicYearLabel.setText("Academic Year (YY)");
				AcademicYearLabel.setHorizontalAlignment(SwingConstants.RIGHT);
				AcademicYearLabel.setEnabled(false);
				contentPanel.add(AcademicYearLabel, cc.xywh(19, 3, 9, 1));

				//---- AcademicYearField ----
				AcademicYearField.setEnabled(false);
				AcademicYearField.setText("YY");
				contentPanel.add(AcademicYearField, cc.xy(29, 3));

				//---- TermLabel ----
				TermLabel.setText("Term");
				TermLabel.setHorizontalAlignment(SwingConstants.CENTER);
				TermLabel.setEnabled(false);
				contentPanel.add(TermLabel, cc.xy(35, 3));

				//---- TermComboBox ----
				TermComboBox.setModel(new DefaultComboBoxModel(new String[] {
					"A",
					"B",
					"C",
					"D",
					"E"
				}));
				TermComboBox.setEnabled(false);
				contentPanel.add(TermComboBox, cc.xywh(37, 3, 2, 1));

				//---- StartDateLabel ----
				StartDateLabel.setText("start date (YYYY-MM-DD)");
				StartDateLabel.setEnabled(false);
				contentPanel.add(StartDateLabel, cc.xywh(1, 7, 5, 1));

				//---- StartDateField ----
				StartDateField.setEnabled(false);
				StartDateField.setText("YYYY-MM-DD");
				contentPanel.add(StartDateField, cc.xywh(7, 7, 6, 1));

				//---- EndDateLabel ----
				EndDateLabel.setText("end date (YYYY-MM-DD)");
				EndDateLabel.setEnabled(false);
				contentPanel.add(EndDateLabel, cc.xywh(17, 7, 5, 1));

				//---- EndDateField ----
				EndDateField.setEnabled(false);
				EndDateField.setText("YYYY-MM-DD");
				contentPanel.add(EndDateField, cc.xywh(23, 7, 7, 1));

				//---- LecturerLabel ----
				LecturerLabel.setText("Lecturer");
				LecturerLabel.setHorizontalAlignment(SwingConstants.CENTER);
				LecturerLabel.setEnabled(false);
				contentPanel.add(LecturerLabel, cc.xywh(1, 11, 3, 1));

				//---- LecturerDisplayField ----
				LecturerDisplayField.setEnabled(false);
				LecturerDisplayField.setEditable(false);
				contentPanel.add(LecturerDisplayField, cc.xywh(5, 11, 5, 1));

				//---- CoordinatorLabel ----
				CoordinatorLabel.setText("Coordinator");
				CoordinatorLabel.setHorizontalAlignment(SwingConstants.CENTER);
				CoordinatorLabel.setEnabled(false);
				contentPanel.add(CoordinatorLabel, cc.xywh(13, 11, 5, 1));

				//---- CoordinatorDisplayField ----
				CoordinatorDisplayField.setEnabled(false);
				CoordinatorDisplayField.setEditable(false);
				contentPanel.add(CoordinatorDisplayField, cc.xywh(19, 11, 5, 1));

				//---- LabCoordinatorLabel ----
				LabCoordinatorLabel.setText("Lab Coordinator");
				LabCoordinatorLabel.setHorizontalAlignment(SwingConstants.CENTER);
				LabCoordinatorLabel.setEnabled(false);
				contentPanel.add(LabCoordinatorLabel, cc.xywh(29, 11, 3, 1));

				//---- LabCoordinatorDisplayField ----
				LabCoordinatorDisplayField.setEnabled(false);
				LabCoordinatorDisplayField.setEditable(false);
				contentPanel.add(LabCoordinatorDisplayField, cc.xywh(33, 11, 5, 1));

				//---- SelectLecturerButton ----
				SelectLecturerButton.setText("Select");
				SelectLecturerButton.setEnabled(false);
				SelectLecturerButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						SelectLecturerButtonActionPerformed(e);
					}
				});
				contentPanel.add(SelectLecturerButton, cc.xy(1, 13));

				//---- AddLecturerButton ----
				AddLecturerButton.setText("+");
				AddLecturerButton.setEnabled(false);
				AddLecturerButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						AddLecturerButtonActionPerformed(e);
					}
				});
				contentPanel.add(AddLecturerButton, cc.xy(5, 13));

				//---- ModifyLecturerButton ----
				ModifyLecturerButton.setText("~");
				ModifyLecturerButton.setEnabled(false);
				ModifyLecturerButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						ModifyLecturerButtonActionPerformed(e);
					}
				});
				contentPanel.add(ModifyLecturerButton, cc.xy(7, 13));

				//---- RemoveLecturerButton ----
				RemoveLecturerButton.setText("-");
				RemoveLecturerButton.setEnabled(false);
				RemoveLecturerButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						RemoveLecturerButtonActionPerformed(e);
					}
				});
				contentPanel.add(RemoveLecturerButton, cc.xy(9, 13));

				//---- SelectCoordinatorButton ----
				SelectCoordinatorButton.setText("Select");
				SelectCoordinatorButton.setEnabled(false);
				SelectCoordinatorButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						SelectCoordinatorButtonActionPerformed(e);
					}
				});
				contentPanel.add(SelectCoordinatorButton, cc.xywh(13, 13, 3, 1));

				//---- AddCoordinatorButton ----
				AddCoordinatorButton.setText("+");
				AddCoordinatorButton.setEnabled(false);
				AddCoordinatorButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						AddCoordinatorButtonActionPerformed(e);
					}
				});
				contentPanel.add(AddCoordinatorButton, cc.xy(19, 13));

				//---- ModifyCoordinatorButton ----
				ModifyCoordinatorButton.setText("~");
				ModifyCoordinatorButton.setEnabled(false);
				ModifyCoordinatorButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						ModifyCoordinatorButtonActionPerformed(e);
					}
				});
				contentPanel.add(ModifyCoordinatorButton, cc.xy(21, 13));

				//---- RemoveCoordinatorButton ----
				RemoveCoordinatorButton.setText("-");
				RemoveCoordinatorButton.setEnabled(false);
				RemoveCoordinatorButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						RemoveCoordinatorButtonActionPerformed(e);
					}
				});
				contentPanel.add(RemoveCoordinatorButton, cc.xy(23, 13));

				//---- SelectLabCoordinatorButton ----
				SelectLabCoordinatorButton.setText("Select");
				SelectLabCoordinatorButton.setEnabled(false);
				SelectLabCoordinatorButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						SelectLabCoordinatorButtonActionPerformed(e);
					}
				});
				contentPanel.add(SelectLabCoordinatorButton, cc.xy(29, 13));

				//---- AddLabCoordinatorButton ----
				AddLabCoordinatorButton.setText("+");
				AddLabCoordinatorButton.setEnabled(false);
				AddLabCoordinatorButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						AddLabCoordinatorButtonActionPerformed(e);
					}
				});
				contentPanel.add(AddLabCoordinatorButton, cc.xy(33, 13));

				//---- ModifyLabCoordinatorButton ----
				ModifyLabCoordinatorButton.setText("~");
				ModifyLabCoordinatorButton.setEnabled(false);
				ModifyLabCoordinatorButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						ModifyLabCoordinatorButtonActionPerformed(e);
					}
				});
				contentPanel.add(ModifyLabCoordinatorButton, cc.xy(35, 13));

				//---- RemoveLabCoordinatorButton ----
				RemoveLabCoordinatorButton.setText("-");
				RemoveLabCoordinatorButton.setEnabled(false);
				RemoveLabCoordinatorButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						RemoveLabCoordinatorButtonActionPerformed(e);
					}
				});
				contentPanel.add(RemoveLabCoordinatorButton, cc.xy(37, 13));

				//======== scrollPane3 ========
				{

					//---- LecturerList ----
					LecturerList.setEnabled(false);
					scrollPane3.setViewportView(LecturerList);
				}
				contentPanel.add(scrollPane3, cc.xywh(1, 15, 9, 3));

				//======== scrollPane4 ========
				{

					//---- CoordinatorList ----
					CoordinatorList.setEnabled(false);
					scrollPane4.setViewportView(CoordinatorList);
				}
				contentPanel.add(scrollPane4, cc.xywh(13, 15, 11, 3));

				//======== scrollPane5 ========
				{

					//---- LabCoordinatorList ----
					LabCoordinatorList.setEnabled(false);
					scrollPane5.setViewportView(LabCoordinatorList);
				}
				contentPanel.add(scrollPane5, cc.xywh(29, 15, 9, 3));

				//---- LabLabel ----
				LabLabel.setText("Labs");
				LabLabel.setEnabled(false);
				contentPanel.add(LabLabel, cc.xywh(1, 21, 3, 1));

				//---- AddLabButton ----
				AddLabButton.setText("+");
				AddLabButton.setEnabled(false);
				AddLabButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						AddLabButtonActionPerformed(e);
					}
				});
				contentPanel.add(AddLabButton, cc.xy(7, 21));

				//---- ModifyLabButton ----
				ModifyLabButton.setText("~");
				ModifyLabButton.setEnabled(false);
				ModifyLabButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						ModifyLabButtonActionPerformed(e);
					}
				});
				contentPanel.add(ModifyLabButton, cc.xy(9, 21));

				//---- RemoveLabButton ----
				RemoveLabButton.setText("-");
				RemoveLabButton.setEnabled(false);
				RemoveLabButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						RemoveLabButtonActionPerformed(e);
					}
				});
				contentPanel.add(RemoveLabButton, cc.xy(11, 21));

				//---- SectionLabel ----
				SectionLabel.setText("Sections");
				SectionLabel.setEnabled(false);
				contentPanel.add(SectionLabel, cc.xy(23, 21));

				//---- AddSectionButton ----
				AddSectionButton.setText("+");
				AddSectionButton.setEnabled(false);
				AddSectionButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						AddSectionButtonActionPerformed(e);
					}
				});
				contentPanel.add(AddSectionButton, cc.xy(33, 21));

				//---- ModifySectionButton ----
				ModifySectionButton.setText("~");
				ModifySectionButton.setEnabled(false);
				ModifySectionButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						ModifySectionButtonActionPerformed(e);
					}
				});
				contentPanel.add(ModifySectionButton, cc.xy(35, 21));

				//---- RemoveSectionButton ----
				RemoveSectionButton.setText("-");
				RemoveSectionButton.setEnabled(false);
				RemoveSectionButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						RemoveSectionButtonActionPerformed(e);
					}
				});
				contentPanel.add(RemoveSectionButton, cc.xy(37, 21));

				//======== scrollPane1 ========
				{

					//---- LabList ----
					LabList.setEnabled(false);
					scrollPane1.setViewportView(LabList);
				}
				contentPanel.add(scrollPane1, cc.xywh(1, 23, 11, 1));

				//======== scrollPane2 ========
				{

					//---- SectionList ----
					SectionList.setEnabled(false);
					scrollPane2.setViewportView(SectionList);
				}
				contentPanel.add(scrollPane2, cc.xywh(23, 23, 15, 1));
			}
			dialogPane.add(contentPanel, BorderLayout.CENTER);

			//======== buttonBar ========
			{
				buttonBar.setBorder(Borders.BUTTON_BAR_GAP_BORDER);
				buttonBar.setLayout(new FormLayout(
					"$glue, $button, $rgap, $button",
					"pref"));

				//---- SaveButton ----
				SaveButton.setText("Save");
				SaveButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						SaveButtonActionPerformed(e);
					}
				});
				buttonBar.add(SaveButton, cc.xy(2, 1));

				//---- cancelButton ----
				cancelButton.setText("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						cancelButtonActionPerformed(e);
					}
				});
				buttonBar.add(cancelButton, cc.xy(4, 1));
			}
			dialogPane.add(buttonBar, BorderLayout.SOUTH);
		}
		contentPane.add(dialogPane, BorderLayout.CENTER);
		pack();
		setLocationRelativeTo(getOwner());
		// JFormDesigner - End of component initialization  //GEN-END:initComponents
	}

	// JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables
	private JPanel dialogPane;
	private JPanel contentPanel;
	private JLabel label1;
	private JTextField CourseTitleField;
	private JLabel CourseNumberLabel;
	private JTextField CourseNumberField;
	private JLabel DepartmentLabel;
	private JTextField DepartmentField;
	private JLabel AcademicYearLabel;
	private JTextField AcademicYearField;
	private JLabel TermLabel;
	private JComboBox TermComboBox;
	private JLabel StartDateLabel;
	private JTextField StartDateField;
	private JLabel EndDateLabel;
	private JTextField EndDateField;
	private JLabel LecturerLabel;
	private JTextField LecturerDisplayField;
	private JLabel CoordinatorLabel;
	private JTextField CoordinatorDisplayField;
	private JLabel LabCoordinatorLabel;
	private JTextField LabCoordinatorDisplayField;
	private JButton SelectLecturerButton;
	private JButton AddLecturerButton;
	private JButton ModifyLecturerButton;
	private JButton RemoveLecturerButton;
	private JButton SelectCoordinatorButton;
	private JButton AddCoordinatorButton;
	private JButton ModifyCoordinatorButton;
	private JButton RemoveCoordinatorButton;
	private JButton SelectLabCoordinatorButton;
	private JButton AddLabCoordinatorButton;
	private JButton ModifyLabCoordinatorButton;
	private JButton RemoveLabCoordinatorButton;
	private JScrollPane scrollPane3;
	private JList LecturerList;
	private JScrollPane scrollPane4;
	private JList CoordinatorList;
	private JScrollPane scrollPane5;
	private JList LabCoordinatorList;
	private JLabel LabLabel;
	private JButton AddLabButton;
	private JButton ModifyLabButton;
	private JButton RemoveLabButton;
	private JLabel SectionLabel;
	private JButton AddSectionButton;
	private JButton ModifySectionButton;
	private JButton RemoveSectionButton;
	private JScrollPane scrollPane1;
	private JList LabList;
	private JScrollPane scrollPane2;
	private JList SectionList;
	private JPanel buttonBar;
	private JButton SaveButton;
	private JButton cancelButton;
	// JFormDesigner - End of variables declaration  //GEN-END:variables
}
