/*
 * Created by JFormDesigner on Wed Dec 02 19:25:56 EST 2009
 */

package WebBuilder;

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.sql.SQLException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

import javax.swing.*;
import javax.swing.border.*;

import com.hexidec.ekit.Ekit;
import com.hexidec.ekit.EkitCore;
import com.jgoodies.forms.layout.*;

/**
 * @author Someone
 */
public class PageElementframe extends JFrame {
	int pElementID;
	int pID;
	File ImageFile;
	int AppletFileID=-1;
	String AppletDirectory=null;
	
	String[][] EventListArray;
	String[][] AppletFileListArray;

	WebpageDB webDB;
	public PageElementframe(WebpageDB db, int page_element_id, int page_id) {
		pElementID = page_element_id;
		pID = page_id;
		webDB = db;
		initComponents();
		
		if( pElementID!=-1) {
			//modify the element
			try {
				String ElementType = webDB.query_single("select element_type from page_element where ID = " + pElementID).toString();
				Integer SpecElementID = Integer.valueOf(webDB.query_single("select elementID from page_element where ID = " + pElementID).toString());
				if (ElementType.equals("html")) {
					/////////////////////
					//LOAD HTML ELEMENT 
					String html_elem_body = webDB.query_single("select html_text from html_element where ID = " + SpecElementID).toString();
					hTMLEditor1.setDocumentText(html_elem_body);
					String title = webDB.query_single("select title from html_element where ID = " + SpecElementID).toString();
					HTMLTitleField.setText(title);

					ElementTabbedPane.setSelectedIndex(0);
					ElementTabbedPane.setEnabledAt(1, false);
					ElementTabbedPane.setEnabledAt(2, false);
					ElementTabbedPane.setEnabledAt(3, false);
				} else if (ElementType.equals("applet")) {
			
//"CREATE TABLE applet_element( ID INTEGER IDENTITY, title VARCHAR(30), type VARCHAR(8), height INTEGER, width INTEGER, code VARCHAR(50), src_applet_file_id INTEGER)");	        
//  	"CREATE TABLE applet_files( ID INTEGER IDENTITY, applet_id INTEGER, directory VARCHAR(256), filename VARCHAR(50))");
					String title = webDB.query_single("select title from applet_element where ID = " + SpecElementID).toString();
					String height = webDB.query_single("select height from applet_element where ID = " + SpecElementID).toString();
					String width = webDB.query_single("select width from applet_element where ID = " + SpecElementID).toString();
					String type = webDB.query_single("select type from applet_element where ID = " + SpecElementID).toString();
					
					if (type=="class") {
						ClassRadioButton.setSelected(true);
						ArchiveRadioButton.setSelected(true);
					} else {
						ClassRadioButton.setSelected(true);
						ArchiveRadioButton.setSelected(true);						
					}
					
					
					AppletTitleField.setText(title);
					AppletHeightField.setText(height);
					AppletWidthField.setText(width);
					
					
					ElementTabbedPane.setEnabledAt(0, false);
					ElementTabbedPane.setSelectedIndex(1);
					ElementTabbedPane.setEnabledAt(2, false);
					ElementTabbedPane.setEnabledAt(3, false);
					
				}else if (ElementType.equals("psched")) {
					String title = webDB.query_single("select schedule_title from p_schedule_element where ID = " + SpecElementID).toString();					
					ScheduleTitleField.setText(title);
					
					ElementTabbedPane.setEnabledAt(0, false);
					ElementTabbedPane.setEnabledAt(1, false);
					ElementTabbedPane.setSelectedIndex(2);
					ElementTabbedPane.setEnabledAt(3, false);
					ModifyEventButton.setEnabled(true);
					AddEventButton.setEnabled(true);
					RemoveEventButton.setEnabled(true);
					EventList.setEnabled(true);
					EventLabel.setEnabled(true);
					
					String[] Events =  getEventList(db);
					EventList.setListData(Events);					
				}else if (ElementType.equals("image")) {
					/////////////////////
					//LOAD IMAGE ELEMENT 					
					String title = webDB.query_single("select title from image_element where ID = " + SpecElementID).toString();
					String filename = webDB.query_single("select filename from image_element where ID = " + SpecElementID).toString();
					String alt_text = webDB.query_single("select alt_text from image_element where ID = " + SpecElementID).toString();
					String align = webDB.query_single("select align from image_element where ID = " + SpecElementID).toString();
					String height = webDB.query_single("select height from image_element where ID = " + SpecElementID).toString();
					String width = webDB.query_single("select width from image_element where ID = " + SpecElementID).toString();
					ImageTitleField.setText(title);
					ImageLocationField.setText(filename);
					alttextField.setText(alt_text);
					ImageHeightField.setText(height);
					ImageAlignComboBox.setSelectedItem(align);
					ImageWidthField.setText(width);
					ImageFile = new File("./" + webDB.DB_NAME + "/" + filename);
					ImageBrowseButton.setEnabled(false);

					ElementTabbedPane.setEnabledAt(0, false);
					ElementTabbedPane.setEnabledAt(1, false);
					ElementTabbedPane.setEnabledAt(2, false);
					ElementTabbedPane.setSelectedIndex(3);
				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}			
			
			
			//webDB.update("INSERT INTO html_element(html_text) VALUES('" + hTMLEditor1.getDocumentBody() + "')");
			//Integer html_elem_id = Integer.valueOf(webDB.query_single("select max(ID) from html_element").toString());
			
			//webDB.update("INSERT INTO page_element(element_type,elementID) VALUES('html', " + html_elem_id + ")");

			
		}

		
	}

	private void cancelButtonActionPerformed(ActionEvent e) {
		// TODO add your code here
		this.setVisible(false);
		this.dispose();
	}

	private Boolean CheckAppletData() {
		Boolean success= true;
		if (CodebaseField.getText().isEmpty()) {
			Interface.ShowMessgaeBox("enter a archive code to proceed");
			success = false;
		}
		if (AppletHeightField.getText().isEmpty()) {
			Interface.ShowMessgaeBox("enter a height to proceed");
			success = false;
		} 
		
		if (AppletWidthField.getText().isEmpty()) {
			Interface.ShowMessgaeBox("enter a width to proceed");
			success = false;
		} 
		

//		if (lecturer_id<0) {
//			Interface.ShowMessgaeBox("select a lecturer from the list");
//			success = false;			
//		}
		if (AppletFileID<0) {
			Interface.ShowMessgaeBox("select an applet executable from the list");
			success = false;			
		}		
		
		return success;
		
	}
	
	
	private void SaveButtonActionPerformed(ActionEvent e) {
		Boolean success= false;
		// TODO add your code here
		if (pElementID==-1) {
        	Integer max_page_order;
        	
			//do insert
			Integer elem_type = ElementTabbedPane.getSelectedIndex();
	        switch (elem_type) {
	            case 0:  
	            	//html
	    			//check that a title is entered
	    			if (!HTMLTitleField.getText().isEmpty()) {
		            	System.out.println("0 insert html element\n"); 
		    			try {
		    				webDB.update("INSERT INTO html_element(title, html_text) VALUES('" + HTMLTitleField.getText().replace("'", "''") + "', '" + hTMLEditor1.getDocumentBody().replace("'", "''") + "')");
		    				Integer html_elem_id = Integer.valueOf(webDB.query_single("select max(ID) from html_element").toString());
		    				
		    				webDB.update("INSERT INTO page_element(element_type,elementID) VALUES('html', " + html_elem_id + ")");
		    				Integer p_elem_id = Integer.valueOf(webDB.query_single("select max(ID) from page_element").toString());
		    				pElementID = p_elem_id;
		    				Integer p_elem_count = Integer.valueOf(webDB.query_single("select count(pElementID) from ref_page_pElement where pageID = " + pID).toString());
		    				if (p_elem_count >0) {
		    					max_page_order = Integer.valueOf(webDB.query_single("select max(page_order) from ref_page_pElement where pageID = " + pID).toString());
		    				} else {
		    					max_page_order = -1;
		    				}
		    				webDB.update("INSERT INTO ref_page_pElement(pageID,pElementID,page_order) VALUES(" + pID + ", " + p_elem_id + "," + (max_page_order+1) + ")");
		    				success = true;
		    			} catch (SQLException e1) {
		    				// TODO Auto-generated catch block
		    				e1.printStackTrace();
		    			}
	    			} else {
	    				Interface.ShowMessgaeBox("enter a title  to proceed");
	    			}				            	
	            	
	            	break;
		        case 1:  
		        	//applet
	    			//check that a title is entered
//					CodebaseField.setEnabled(true);
//					EventList.setEnabled(true);
//					EventLabel.setEnabled(true);
//					AppletHeightLabel.setEnabled(true);
//					AppletHeightField.setEnabled(true);
//					AppletWidthField.setEnabled(true);
//					AppletWidthLabel.setEnabled(true);
//					ClassRadioButton.setEnabled(true);
//					ArchiveRadioButton.setEnabled(true);
		        	if (!AppletTitleField.getText().isEmpty()) {
		        		if (CheckAppletData()) {
		        			try {
		        				String type = "";
		        				String code = "";
	        					if (ClassRadioButton.isSelected()) { 
	        						type = "class";
	        					}
	        					if (ArchiveRadioButton.isSelected()) { 
	        						type = "class";
	        					}
	        					if (CodebaseField.isEnabled()) {
	        						code = "'" + CodebaseField.getText() + "'";
	        					} else {
	        						code = "NULL";
	        					}
		        				//				"CREATE TABLE applet_element( ID INTEGER IDENTITY, title VARCHAR(30), type VARCHAR(8), height INTEGER, width INTEGER, code VARCHAR(50), src_applet_file_id INTEGER, directory VARCHAR(256))");
			    				webDB.update("UPDATE applet_element SET title = '" + AppletTitleField.getText() + "', type = '" + type + "', height = " + AppletHeightField.getText() + ", width = " + AppletWidthField.getText() + ", code = " + code + ", src_applet_file_id = " + AppletFileID + ", directory = '" + AppletDirectory + "'");
			    				success = true;
			    			} catch (SQLException e1) {
			    				// TODO Auto-generated catch block
			    				e1.printStackTrace();
			    			}
			        		System.out.println("1"); 
			        		success = true;
		        		}
	    			} else {
	    				Interface.ShowMessgaeBox("enter a title  to proceed");
	    			}		
	            	break;
	            case 2:
	            	//personal schedule
		        	if (!ScheduleTitleField.getText().isEmpty()) {
		        		System.out.println("2");
		    			try {
		    				Integer SpecElementID = Integer.valueOf(webDB.query_single("select elementID from page_element where ID = " + pElementID).toString());
							webDB.update("UPDATE p_schedule_element SET schedule_title = '" + ScheduleTitleField.getText().replace("'", "''") + "' where ID = " + SpecElementID);
							success = true;
		    			} catch (SQLException e1) {
		    				// TODO Auto-generated catch block
		    				e1.printStackTrace();
		    			}	 
	    			} else {
	    				Interface.ShowMessgaeBox("enter a title  to proceed");
	    			}		
		        	break;
	            case 3:
	            	//image
	    			//check that a title is entered
	    			if (!ImageTitleField.getText().isEmpty()) {
	    				//check that the file exists
	    				if (ImageFile!=null) {
	    					System.out.print("./" + webDB.DB_NAME + "/" + ImageFile.getName());
	    					File testFile = new File("./" + webDB.DB_NAME + "/" + ImageFile.getName());
	    					if (!testFile.exists()) {
	    						//copy it to the webdb directory
	    						try {
	    							FileInputStream fis = new FileInputStream(ImageFile);
	    						    FileOutputStream fos = new FileOutputStream(new File("./" + webDB.DB_NAME + "/" + ImageFile.getName()));
	    						    try {
	    						        byte[] buf = new byte[1024];
	    						        int i = 0;
	    						        while ((i = fis.read(buf)) != -1) {
	    						            fos.write(buf, 0, i);
	    						        }
	    						    } 
	    						    catch (Exception e1) {
	    						        throw e1;
	    						    }
	    						    finally {
	    						        if (fis != null) fis.close();
	    						        if (fos != null) fos.close();
	    						    }
	    						} catch (Exception e2) {
	    							// TODO Auto-generated catch block
	    							e2.printStackTrace();
	    						}
	    						
				            	System.out.println("0 insert image element\n"); 
				    			try {
				    					    				
				    				webDB.update("INSERT INTO image_element(title, filename, alt_text, align, height, width) VALUES('" + ImageTitleField.getText().replace("'", "''") + "', '" + ImageFile.getName() + "', '" + alttextField.getText().replace("'", "''") + "', '" + ImageAlignComboBox.getSelectedItem() + "', " + ImageHeightField.getText() + "," + ImageWidthField.getText() + ")");
				    				Integer image_elem_id = Integer.valueOf(webDB.query_single("select max(ID) from image_element").toString());
				    				
				    				webDB.update("INSERT INTO page_element(element_type,elementID) VALUES('image', " + image_elem_id + ")");
				    				Integer p_elem_id = Integer.valueOf(webDB.query_single("select max(ID) from page_element").toString());
				    				pElementID = p_elem_id;
				    				Integer p_elem_count = Integer.valueOf(webDB.query_single("select count(pElementID) from ref_page_pElement where pageID = " + pID).toString());
				    				if (p_elem_count >0) {
				    					max_page_order = Integer.valueOf(webDB.query_single("select max(page_order) from ref_page_pElement where pageID = " + pID).toString());
				    				} else {
				    					max_page_order = -1;
				    				}
				    				webDB.update("INSERT INTO ref_page_pElement(pageID,pElementID,page_order) VALUES(" + pID + ", " + p_elem_id + "," + (max_page_order+1) + ")");
				    				success = true;
				    			} catch (SQLException e1) {
				    				// TODO Auto-generated catch block
				    				e1.printStackTrace();
				    			}	            	
	    					} else {
	    						Interface.ShowMessgaeBox("there is already a file of that name in the database, please rename the file and try again");
	    					}		
	    				} else {
	    					Interface.ShowMessgaeBox("select a document using the browse button to proceed");
	    				}					
	    			} else {
	    				Interface.ShowMessgaeBox("enter a title for the document to proceed");
	    			}				            	
	            	break;
	            default: System.out.println("Invalid.");break;
	        }

			
			
		} else {
			//do update of page element
			Integer elem_type = ElementTabbedPane.getSelectedIndex();
	        switch (elem_type) {
	            case 0:  
	            	//html
	            	
	            	//here we should check stuff
	            	
	            	System.out.println("0 update html element\n"); 
	    			try {
	    				Integer SpecElementID = Integer.valueOf(webDB.query_single("select elementID from page_element where ID = " + pElementID).toString());
						webDB.update("UPDATE html_element SET title = '" + HTMLTitleField.getText().replace("'", "''") + "', html_text = '" + hTMLEditor1.getDocumentBody().replace("'", "''") + "' where ID = " + SpecElementID);
						success = true;
	    			} catch (SQLException e1) {
	    				// TODO Auto-generated catch block
	    				e1.printStackTrace();
	    			}
	            	break;
		        case 1:  
		        	//applet
	            	System.out.println("1"); 
	            ///////////////
	            	///////////////
	            	///////////
	            	//////////////
	            	////////////////this needs code
	            	//////////////////////
	            	break;
	            case 2:
	            	//personal schedule
	            	System.out.println("2"); 
	    			try {
	    				Integer SpecElementID = Integer.valueOf(webDB.query_single("select elementID from page_element where ID = " + pElementID).toString());
						webDB.update("UPDATE p_schedule_element SET schedule_title = '" + ScheduleTitleField.getText() + "' where ID = " + SpecElementID);
						success = true;
	    			} catch (SQLException e1) {
	    				// TODO Auto-generated catch block
	    				e1.printStackTrace();
	    			}	 
	    			break;
	            case 3:
	            	//image
	            	
	            	//here we should check stuff
	            	
	            	
	            	System.out.println("3 update image element\n"); 
	    			try {
	    				Integer SpecElementID = Integer.valueOf(webDB.query_single("select elementID from page_element where ID = " + pElementID).toString());
						webDB.update("UPDATE image_element SET schedule_title = '" + ImageTitleField.getText() + "', alt_text = '" + alttextField.getText() + "', align = '" + ImageAlignComboBox.getSelectedItem() + "', height = " + ImageHeightField.getText() + ", width = " + ImageWidthField.getText() + " where ID = " + SpecElementID);
						success = true;
	    			} catch (SQLException e1) {
	    				// TODO Auto-generated catch block
	    				e1.printStackTrace();
	    			}

	    			break;
	            default: System.out.println("Invalid.");break;
	        }			
		}
		
		if (success) {
			this.setVisible(false);
			this.dispose();
		}
	}


	private void ImageBrowseButtonActionPerformed(ActionEvent e) {
		// TODO add your code here
        final JFileChooser fc = new JFileChooser();
        fc.setCurrentDirectory(new File("./"));
        
        fc.showOpenDialog(this);

        // Get the selected file
        File selFile = fc.getSelectedFile();
        //System.out.print(selFile);
        if (selFile!=null){
        	ImageFile = selFile;
        	ImageLocationField.setText(selFile.getAbsolutePath());
        }		
	}

	
	private String[] getEventList(WebpageDB db) {
		
		//query_array("select");
		String[] returnString = new String[]{"a", "b"};
		Integer page_count;

		try {
			Integer SpecElementID = Integer.valueOf(webDB.query_single("select elementID from page_element where ID = " + pElementID).toString());
			page_count = Integer.valueOf(db.query_single("select count(ID) from sched_event where schedID = " + SpecElementID).toString());
			if (page_count > 0) {
				
				String[][] Events = db.query_array("SELECT ID, MON, TUE, WED, THU, FRI, starttime, endtime, event_text FROM sched_event where schedID = " + SpecElementID );
				
				//set the global variable
				EventListArray = Events;
				
//				db.query("Select ref_page_pElement.pElementID, page_element.element_type from ref_page_pElement inner join page_element on ref_page_pElement.pElementID=page_element.ID where pageID = " + p_id);
				ArrayList<String> titles = new ArrayList<String>();

				for (int i = 0; i <Events.length;i++ ){
					System.out.print(Events[i][0] + "\n");
					System.out.print(Events[i][8] + "\n");
					String elementTitle = "";
					if (Boolean.parseBoolean(Events[i][1])){
						elementTitle = elementTitle + "M"; 
					}
					if (Boolean.parseBoolean(Events[i][2])){
						elementTitle = elementTitle + "T"; 
					}
					if (Boolean.parseBoolean(Events[i][3])){
						elementTitle = elementTitle + "W"; 
					}
					if (Boolean.parseBoolean(Events[i][4])){
						elementTitle = elementTitle + "H"; 
					}
					if (Boolean.parseBoolean(Events[i][5])){
						elementTitle = elementTitle + "F"; 
					}
					elementTitle = elementTitle + " " + Events[i][6] + "-" + Events[i][7] + " " + Events[i][8];
					
					titles.add( elementTitle );
					
				}
				Object[] ObjArray =  titles.toArray();
				
				returnString = new String[ObjArray.length];
				for (int j = 0 ; j<ObjArray.length;j++){
					returnString[j] = ObjArray[j].toString();
				}
			} else {
				returnString = new String[]{};
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return returnString;
	
	
	}

	private void ScheduleTitleFieldActionPerformed(ActionEvent e) {
		// TODO add your code here
		if (!ScheduleTitleField.getText().isEmpty()) {
			if (pElementID == -1) { 


				int max_page_order;
    			try {
    				
    				webDB.update("INSERT INTO p_schedule_element(schedule_title) VALUES('" + ScheduleTitleField.getText() + "')");
    				Integer p_schedule_element_id = Integer.valueOf(webDB.query_single("select max(ID) from p_schedule_element").toString());
    				
    				webDB.update("INSERT INTO page_element(element_type,elementID) VALUES('psched', " + p_schedule_element_id + ")");
    				Integer p_elem_id = Integer.valueOf(webDB.query_single("select max(ID) from page_element").toString());
    				pElementID = p_elem_id;
    				Integer p_elem_count = Integer.valueOf(webDB.query_single("select count(pElementID) from ref_page_pElement where pageID = " + pID).toString());
    				if (p_elem_count >0) {
    					max_page_order = Integer.valueOf(webDB.query_single("select max(page_order) from ref_page_pElement where pageID = " + pID).toString());
    				} else {
    					max_page_order = -1;
    				}
    				webDB.update("INSERT INTO ref_page_pElement(pageID,pElementID,page_order) VALUES(" + pID + ", " + p_elem_id + "," + (max_page_order+1) + ")");
    			} catch (SQLException e1) {
    				// TODO Auto-generated catch block
    				e1.printStackTrace();
    			}				
				ElementTabbedPane.setEnabledAt(0, false);
				ElementTabbedPane.setEnabledAt(1, false);
				ElementTabbedPane.setSelectedIndex(2);
				ElementTabbedPane.setEnabledAt(3, false);
//				ElementTabbedPane.setEnabledAt(4, false);
				ModifyEventButton.setEnabled(true);
				AddEventButton.setEnabled(true);
				RemoveEventButton.setEnabled(true);
				EventList.setEnabled(true);
				EventLabel.setEnabled(true);
			}
		} else {
			Interface.ShowMessgaeBox("enter a title for the page to proceed");
			
		}
		
	}

	private void AddEventButtonActionPerformed(ActionEvent e) {
		// TODO add your code here
		Integer SpecElementID = null;
		try {
			SpecElementID = Integer.valueOf(webDB.query_single("select elementID from page_element where ID = " + pElementID).toString());
		} catch (NumberFormatException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (SQLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		ScheduleEventframe add_Eventframe = new ScheduleEventframe(webDB, -1, SpecElementID);
		add_Eventframe.show();
	
	}

	private void AppletBrowseButtonActionPerformed(ActionEvent e) {
		
		if (AppletDirectory==null){
			
			if (AppletTitleField.getText().isEmpty()) {
				Interface.ShowMessgaeBox("enter a title for the document to proceed");
				return;
			}
			AppletDirectory = AppletTitleField.getText().replace(" ", "").toLowerCase();
		    // Create one directory
		    boolean success = (new File("./" + webDB.DB_NAME + "/" + AppletDirectory)).mkdir();
		    if (success) {
		      System.out.println("Directory: " + AppletDirectory + " created");
		    } else {
		    	//AppletDirectory = null;
		    	//Interface.ShowMessgaeBox("enter a title for the document to proceed");
		    	
		    }
		}
		
	
        final JFileChooser fc = new JFileChooser();
        fc.setCurrentDirectory(new File("./"));
        
        fc.showOpenDialog(this);

        // Get the selected file
        File selFile = fc.getSelectedFile();
        //System.out.print(selFile);
        if (selFile!=null){
        	//FileLocationField.setText(selFile.getAbsolutePath());
			System.out.print("./" + webDB.DB_NAME + "/" + AppletDirectory + "/" + selFile.getName());
			File testFile = new File("./" + webDB.DB_NAME +  "/" + AppletDirectory + "/" + selFile.getName());
			if (!testFile.exists()) {
				//copy it to the webdb directory
				try {
					FileInputStream fis = new FileInputStream(selFile);
				    FileOutputStream fos = new FileOutputStream(new File("./" + webDB.DB_NAME +  "/" + AppletDirectory + "/" + selFile.getName()));
				    try {
				        byte[] buf = new byte[1024];
				        int i = 0;
				        while ((i = fis.read(buf)) != -1) {
				            fos.write(buf, 0, i);
				        }
				    } 
				    catch (Exception e1) {
				        throw e1;
				    }
				    finally {
				        if (fis != null) fis.close();
				        if (fos != null) fos.close();
				    }
				} catch (Exception e2) {
					// TODO Auto-generated catch block
					e2.printStackTrace();
				}

				
				
				//insert the row into the document table			
				try {

	            	//"CREATE TABLE applet_files( ID INTEGER IDENTITY, applet_id INTEGER,directory VARCHAR(256), filename VARCHAR(50))");
    				Integer SpecElementID = Integer.valueOf(webDB.query_single("select elementID from page_element where ID = " + pElementID).toString());
    				webDB.update("INSERT INTO applet_files(applet_id, directory, filename) VALUES('" + SpecElementID + "', '" + AppletDirectory + "','" + selFile.getName()  + "')");
				} catch (SQLException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
        }
		
		
	}

	private void thisWindowGainedFocus(WindowEvent e) {
		// TODO add your code here
		if ( ElementTabbedPane.getSelectedIndex()==2) {
	
			String[] Events =  getEventList(webDB);
			EventList.setListData(Events);
		}
		if ( ElementTabbedPane.getSelectedIndex()==1) {
			
			String[] AppletFiles =  getAppletFileList(webDB);
			AppletFileList.setListData(AppletFiles);
		}
		
	}
	  private String[] getAppletFileList(WebpageDB db) {
			//query_array("select");
			String[] returnString = new String[]{"a", "b"};
			Integer page_count;

			try {
				//"CREATE TABLE applet_files( ID INTEGER IDENTITY, applet_id INTEGER,directory VARCHAR(256), filename VARCHAR(50))");
				page_count = Integer.valueOf(db.query_single("select count(ID) from applet_files where applet_id = " + pElementID).toString());
				if (page_count > 0) {
					
					String[][] appletfiles = db.query_array("SELECT ID,filename FROM applet_files where applet_id = " + pElementID );
					
					//set the global variable
					AppletFileListArray = appletfiles;
					
//					db.query("Select ref_page_pElement.pElementID, page_element.element_type from ref_page_pElement inner join page_element on ref_page_pElement.pElementID=page_element.ID where pageID = " + p_id);
					ArrayList<String> titles = new ArrayList<String>();

					for (int i = 0; i <appletfiles.length;i++ ){
						System.out.print(appletfiles[i][0] + "\n");
						System.out.print(appletfiles[i][1] + "\n");
						String elementTitle = "";
						elementTitle = "[" + appletfiles[i][0] + "] " + appletfiles[i][1];
						
						titles.add( elementTitle );
						
					}
					Object[] ObjArray =  titles.toArray();
					
					returnString = new String[ObjArray.length];
					for (int j = 0 ; j<ObjArray.length;j++){
						returnString[j] = ObjArray[j].toString();
					}
				} else {
					returnString = new String[]{};
				}
			} catch (SQLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			return returnString;
	  }
	
	private void ModifyEventButtonActionPerformed(ActionEvent e) {
		// TODO add your code here
		if (EventList.isSelectionEmpty()){
			Interface.ShowMessgaeBox("you must select an item from the event list to be modify");
			
		} else {
			ScheduleEventframe add_Eventframe = new ScheduleEventframe(webDB, Integer.valueOf(EventListArray[EventList.getSelectedIndex()][0]), pElementID);
			add_Eventframe.show();
		}
	}

	private void RemoveEventButtonActionPerformed(ActionEvent e) {
		// TODO add your code here
		if (EventList.isSelectionEmpty()){
			Interface.ShowMessgaeBox("you must select an item from the event list to be removed");
			
		} else {
			int Event_index_toRemove = EventList.getSelectedIndex();
			int EventID_toremove = Integer.valueOf(EventListArray[Event_index_toRemove][0]);
			try {
				webDB.update("Delete from sched_event where ID = " + EventID_toremove);
			} catch (SQLException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}			
			
		}
		String[] Events =  getEventList(webDB);
		EventList.setListData(Events);
		
	}

	private void AppletTitleFieldActionPerformed(ActionEvent e) {
		if (!AppletTitleField.getText().isEmpty()) {
			if (pElementID == -1) { 


				int max_page_order;
    			try {
    				
    				webDB.update("INSERT INTO applet_element(title) VALUES('" + AppletTitleField.getText() + "')");
    				Integer applet_element_id = Integer.valueOf(webDB.query_single("select max(ID) from applet_element").toString());
    				
    				webDB.update("INSERT INTO page_element(element_type,elementID) VALUES('applet', " + applet_element_id + ")");
    				Integer p_elem_id = Integer.valueOf(webDB.query_single("select max(ID) from page_element").toString());
    				pElementID = p_elem_id;
    				Integer p_elem_count = Integer.valueOf(webDB.query_single("select count(pElementID) from ref_page_pElement where pageID = " + pID).toString());
    				if (p_elem_count >0) {
    					max_page_order = Integer.valueOf(webDB.query_single("select max(page_order) from ref_page_pElement where pageID = " + pID).toString());
    				} else {
    					max_page_order = -1;
    				}
    				webDB.update("INSERT INTO ref_page_pElement(pageID,pElementID,page_order) VALUES(" + pID + ", " + p_elem_id + "," + (max_page_order+1) + ")");
    			} catch (SQLException e1) {
    				// TODO Auto-generated catch block
    				e1.printStackTrace();
    			}	
				ElementTabbedPane.setEnabledAt(0, false);
				ElementTabbedPane.setSelectedIndex(1);
				ElementTabbedPane.setEnabledAt(2, false);
				ElementTabbedPane.setEnabledAt(3, false);
				AppletExecutableLabel.setEnabled(true);
				AppletFileLocationField.setEditable(true);
				AppletFilesLabel.setEnabled(true);
				AppletFileList.setEnabled(true);
				SelectAppletExecutable.setEnabled(true);
				AppletBrowseButton.setEnabled(true);
				CodebaseField.setEnabled(true);
				EventList.setEnabled(true);
				EventLabel.setEnabled(true);
				AppletHeightLabel.setEnabled(true);
				AppletHeightField.setEnabled(true);
				AppletWidthField.setEnabled(true);
				AppletWidthLabel.setEnabled(true);
				ClassRadioButton.setEnabled(true);
				ArchiveRadioButton.setEnabled(true);
			}
		} else {
			Interface.ShowMessgaeBox("enter a title for the page to proceed");
			
		}
	}

	private void SelectAppletExecutableActionPerformed(ActionEvent e) {
		// TODO add your code here
		if (AppletFileList.isSelectionEmpty()) {
			  Interface.ShowMessgaeBox("Select an file to assign as the executable for the applet");
			  return;
			  
		  } else {
			  int coord_id = Integer.valueOf(AppletFileListArray[AppletFileList.getSelectedIndex()][0]);
			  AppletFileID = coord_id;
		  }
		  AppletFileLocationField.setText(AppletFileListArray[AppletFileList.getSelectedIndex()][1]);
	}

	private void ClassRadioButtonActionPerformed(ActionEvent e) {
		if (ClassRadioButton.isSelected()) {
			CodebaseField.setEnabled(false);
			
		} else {
			CodebaseField.setEnabled(true);
		}
	}

	private void ArchiveRadioButtonActionPerformed(ActionEvent e) {
		if (ArchiveRadioButton.isSelected()) {
			CodebaseField.setEnabled(true);
			AppletCodeLabel.setEnabled(true);
		} else {
			CodebaseField.setEnabled(false);
		}
	}
	
	
	private void initComponents() {
		// JFormDesigner - Component initialization - DO NOT MODIFY  //GEN-BEGIN:initComponents
		dialogPane = new JPanel();
		contentPanel = new JPanel();
		ElementTabbedPane = new JTabbedPane();
		panel1 = new JPanel();
		label5 = new JLabel();
		HTMLTitleField = new JTextField();
		hTMLEditor1 = new HTMLEditor();
		panel2 = new JPanel();
		label9 = new JLabel();
		AppletTitleField = new JTextField();
		AppletExecutableLabel = new JLabel();
		AppletFileLocationField = new JTextField();
		AppletFilesLabel = new JLabel();
		scrollPane2 = new JScrollPane();
		AppletFileList = new JList();
		SelectAppletExecutable = new JButton();
		AppletBrowseButton = new JButton();
		AppletCodeLabel = new JLabel();
		CodebaseField = new JTextField();
		AppletHeightLabel = new JLabel();
		AppletHeightField = new JTextField();
		ClassRadioButton = new JRadioButton();
		AppletWidthLabel = new JLabel();
		AppletWidthField = new JTextField();
		ArchiveRadioButton = new JRadioButton();
		panel3 = new JPanel();
		label3 = new JLabel();
		ScheduleTitleField = new JTextField();
		EventLabel = new JLabel();
		AddEventButton = new JButton();
		ModifyEventButton = new JButton();
		RemoveEventButton = new JButton();
		scrollPane1 = new JScrollPane();
		EventList = new JList();
		panel4 = new JPanel();
		label8 = new JLabel();
		ImageTitleField = new JTextField();
		label11 = new JLabel();
		ImageLocationField = new JTextField();
		ImageBrowseButton = new JButton();
		label10 = new JLabel();
		alttextField = new JTextField();
		label14 = new JLabel();
		ImageAlignComboBox = new JComboBox();
		label12 = new JLabel();
		ImageHeightField = new JTextField();
		label13 = new JLabel();
		ImageWidthField = new JTextField();
		buttonBar = new JPanel();
		SaveButton = new JButton();
		cancelButton = new JButton();
		CellConstraints cc = new CellConstraints();

		//======== this ========
		setTitle("Page Element");
		addWindowFocusListener(new WindowAdapter() {
			@Override
			public void windowGainedFocus(WindowEvent e) {
				thisWindowGainedFocus(e);
			}
		});
		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout());

		//======== dialogPane ========
		{
			dialogPane.setBorder(new EmptyBorder(12, 12, 12, 12));
			dialogPane.setLayout(new BorderLayout());

			//======== contentPanel ========
			{
				contentPanel.setLayout(new BoxLayout(contentPanel, BoxLayout.X_AXIS));

				//======== ElementTabbedPane ========
				{

					//======== panel1 ========
					{
						panel1.setLayout(new FormLayout(
							"63dlu, $lcgap, 29dlu, $lcgap, 37dlu, $lcgap, 52dlu, $lcgap, 193dlu",
							"default, $lgap, 237dlu, 2*($lgap, default)"));

						//---- label5 ----
						label5.setText(" Title");
						panel1.add(label5, cc.xy(1, 1));
						panel1.add(HTMLTitleField, cc.xywh(3, 1, 5, 1));
						panel1.add(hTMLEditor1, cc.xywh(1, 3, 9, 3));
					}
					ElementTabbedPane.addTab("HTML", panel1);


					//======== panel2 ========
					{
						panel2.setLayout(new FormLayout(
							"50dlu, $lcgap, 35dlu, $lcgap, 63dlu, $lcgap, 53dlu, $lcgap, 80dlu, $lcgap, 73dlu",
							"2*(default, $lgap), 2*(17dlu, $lgap), 29dlu, 4*($lgap, default)"));

						//---- label9 ----
						label9.setText("title");
						panel2.add(label9, cc.xy(1, 1));

						//---- AppletTitleField ----
						AppletTitleField.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent e) {
								AppletTitleFieldActionPerformed(e);
							}
						});
						panel2.add(AppletTitleField, cc.xywh(3, 1, 3, 1));

						//---- AppletExecutableLabel ----
						AppletExecutableLabel.setText("applet executable(jar or class file)");
						AppletExecutableLabel.setEnabled(false);
						panel2.add(AppletExecutableLabel, cc.xywh(1, 3, 5, 1));

						//---- AppletFileLocationField ----
						AppletFileLocationField.setEditable(false);
						AppletFileLocationField.setEnabled(false);
						panel2.add(AppletFileLocationField, cc.xywh(7, 3, 3, 1));

						//---- AppletFilesLabel ----
						AppletFilesLabel.setText("applet files");
						AppletFilesLabel.setEnabled(false);
						panel2.add(AppletFilesLabel, cc.xywh(1, 5, 3, 1));

						//======== scrollPane2 ========
						{

							//---- AppletFileList ----
							AppletFileList.setEnabled(false);
							scrollPane2.setViewportView(AppletFileList);
						}
						panel2.add(scrollPane2, cc.xywh(5, 5, 3, 5));

						//---- SelectAppletExecutable ----
						SelectAppletExecutable.setText("Select Executables");
						SelectAppletExecutable.setEnabled(false);
						SelectAppletExecutable.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent e) {
								SelectAppletExecutableActionPerformed(e);
							}
						});
						panel2.add(SelectAppletExecutable, cc.xy(9, 5));

						//---- AppletBrowseButton ----
						AppletBrowseButton.setText("add file");
						AppletBrowseButton.setEnabled(false);
						AppletBrowseButton.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent e) {
								AppletBrowseButtonActionPerformed(e);
							}
						});
						panel2.add(AppletBrowseButton, cc.xy(9, 7));

						//---- AppletCodeLabel ----
						AppletCodeLabel.setText("archive code");
						AppletCodeLabel.setEnabled(false);
						panel2.add(AppletCodeLabel, cc.xy(1, 11));

						//---- CodebaseField ----
						CodebaseField.setEnabled(false);
						panel2.add(CodebaseField, cc.xywh(3, 11, 3, 1));

						//---- AppletHeightLabel ----
						AppletHeightLabel.setText("height");
						AppletHeightLabel.setEnabled(false);
						panel2.add(AppletHeightLabel, cc.xy(1, 13));

						//---- AppletHeightField ----
						AppletHeightField.setEnabled(false);
						panel2.add(AppletHeightField, cc.xy(3, 13));

						//---- ClassRadioButton ----
						ClassRadioButton.setText("class");
						ClassRadioButton.setEnabled(false);
						ClassRadioButton.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent e) {
								ClassRadioButtonActionPerformed(e);
							}
						});
						panel2.add(ClassRadioButton, cc.xy(7, 13));

						//---- AppletWidthLabel ----
						AppletWidthLabel.setText("width");
						AppletWidthLabel.setEnabled(false);
						panel2.add(AppletWidthLabel, cc.xy(1, 15));

						//---- AppletWidthField ----
						AppletWidthField.setEnabled(false);
						panel2.add(AppletWidthField, cc.xy(3, 15));

						//---- ArchiveRadioButton ----
						ArchiveRadioButton.setText("archive");
						ArchiveRadioButton.setEnabled(false);
						ArchiveRadioButton.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent e) {
								ArchiveRadioButtonActionPerformed(e);
							}
						});
						panel2.add(ArchiveRadioButton, cc.xy(7, 15));
					}
					ElementTabbedPane.addTab("Applet", panel2);


					//======== panel3 ========
					{
						panel3.setLayout(new FormLayout(
							"default, $lcgap, 52dlu, 5*($lcgap, default)",
							"5*(default, $lgap), default"));

						//---- label3 ----
						label3.setText("Schedule Title");
						panel3.add(label3, cc.xy(3, 1));

						//---- ScheduleTitleField ----
						ScheduleTitleField.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent e) {
								ScheduleTitleFieldActionPerformed(e);
							}
						});
						panel3.add(ScheduleTitleField, cc.xywh(5, 1, 5, 1));

						//---- EventLabel ----
						EventLabel.setText("Events");
						EventLabel.setEnabled(false);
						panel3.add(EventLabel, cc.xy(3, 5));

						//---- AddEventButton ----
						AddEventButton.setText("+");
						AddEventButton.setEnabled(false);
						AddEventButton.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent e) {
								AddEventButtonActionPerformed(e);
							}
						});
						panel3.add(AddEventButton, cc.xy(7, 5));

						//---- ModifyEventButton ----
						ModifyEventButton.setText("~");
						ModifyEventButton.setEnabled(false);
						ModifyEventButton.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent e) {
								ModifyEventButtonActionPerformed(e);
							}
						});
						panel3.add(ModifyEventButton, cc.xy(9, 5));

						//---- RemoveEventButton ----
						RemoveEventButton.setText("-");
						RemoveEventButton.setEnabled(false);
						RemoveEventButton.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent e) {
								RemoveEventButtonActionPerformed(e);
							}
						});
						panel3.add(RemoveEventButton, cc.xy(11, 5));

						//======== scrollPane1 ========
						{

							//---- EventList ----
							EventList.setEnabled(false);
							scrollPane1.setViewportView(EventList);
						}
						panel3.add(scrollPane1, cc.xywh(3, 7, 9, 1));
					}
					ElementTabbedPane.addTab("Personal Schedule", panel3);


					//======== panel4 ========
					{
						panel4.setLayout(new FormLayout(
							"2*(default, $lcgap), 43dlu, $lcgap, default, $lcgap, 53dlu, $lcgap, 66dlu, 3*($lcgap, default)",
							"6*(default, $lgap), default"));

						//---- label8 ----
						label8.setText("Title");
						panel4.add(label8, cc.xy(3, 1));
						panel4.add(ImageTitleField, cc.xywh(5, 1, 5, 1));

						//---- label11 ----
						label11.setText("Filename");
						panel4.add(label11, cc.xy(3, 3));

						//---- ImageLocationField ----
						ImageLocationField.setEditable(false);
						panel4.add(ImageLocationField, cc.xywh(5, 3, 5, 1));

						//---- ImageBrowseButton ----
						ImageBrowseButton.setText("browse");
						ImageBrowseButton.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent e) {
								ImageBrowseButtonActionPerformed(e);
							}
						});
						panel4.add(ImageBrowseButton, cc.xywh(10, 3, 2, 1));

						//---- label10 ----
						label10.setText("Alt Text");
						panel4.add(label10, cc.xy(3, 5));
						panel4.add(alttextField, cc.xywh(5, 5, 5, 1));

						//---- label14 ----
						label14.setText("alignment");
						panel4.add(label14, cc.xy(3, 7));

						//---- ImageAlignComboBox ----
						ImageAlignComboBox.setModel(new DefaultComboBoxModel(new String[] {
							"middle",
							"texttop",
							"top",
							"absmiddle",
							"bottom",
							"baseline",
							"absbottom"
						}));
						panel4.add(ImageAlignComboBox, cc.xywh(5, 7, 3, 1));

						//---- label12 ----
						label12.setText("height");
						panel4.add(label12, cc.xy(3, 9));
						panel4.add(ImageHeightField, cc.xywh(5, 9, 3, 1));

						//---- label13 ----
						label13.setText("width");
						panel4.add(label13, cc.xy(3, 11));
						panel4.add(ImageWidthField, cc.xywh(5, 11, 3, 1));
					}
					ElementTabbedPane.addTab("Image", panel4);

				}
				contentPanel.add(ElementTabbedPane);
			}
			dialogPane.add(contentPanel, BorderLayout.CENTER);

			//======== buttonBar ========
			{
				buttonBar.setBorder(new EmptyBorder(12, 0, 0, 0));
				buttonBar.setLayout(new GridBagLayout());
				((GridBagLayout)buttonBar.getLayout()).columnWidths = new int[] {0, 85, 80};
				((GridBagLayout)buttonBar.getLayout()).columnWeights = new double[] {1.0, 0.0, 0.0};

				//---- SaveButton ----
				SaveButton.setText("Save");
				SaveButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						SaveButtonActionPerformed(e);
					}
				});
				buttonBar.add(SaveButton, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0,
					GridBagConstraints.CENTER, GridBagConstraints.BOTH,
					new Insets(0, 0, 0, 5), 0, 0));

				//---- cancelButton ----
				cancelButton.setText("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						cancelButtonActionPerformed(e);
					}
				});
				buttonBar.add(cancelButton, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0,
					GridBagConstraints.CENTER, GridBagConstraints.BOTH,
					new Insets(0, 0, 0, 0), 0, 0));
			}
			dialogPane.add(buttonBar, BorderLayout.SOUTH);
		}
		contentPane.add(dialogPane, BorderLayout.NORTH);
		pack();
		setLocationRelativeTo(getOwner());

		//---- buttonGroup1 ----
		ButtonGroup buttonGroup1 = new ButtonGroup();
		buttonGroup1.add(ClassRadioButton);
		buttonGroup1.add(ArchiveRadioButton);
		// JFormDesigner - End of component initialization  //GEN-END:initComponents
	}

	// JFormDesigner - Variables declaration - DO NOT MODIFY  //GEN-BEGIN:variables
	private JPanel dialogPane;
	private JPanel contentPanel;
	private JTabbedPane ElementTabbedPane;
	private JPanel panel1;
	private JLabel label5;
	private JTextField HTMLTitleField;
	private HTMLEditor hTMLEditor1;
	private JPanel panel2;
	private JLabel label9;
	private JTextField AppletTitleField;
	private JLabel AppletExecutableLabel;
	private JTextField AppletFileLocationField;
	private JLabel AppletFilesLabel;
	private JScrollPane scrollPane2;
	private JList AppletFileList;
	private JButton SelectAppletExecutable;
	private JButton AppletBrowseButton;
	private JLabel AppletCodeLabel;
	private JTextField CodebaseField;
	private JLabel AppletHeightLabel;
	private JTextField AppletHeightField;
	private JRadioButton ClassRadioButton;
	private JLabel AppletWidthLabel;
	private JTextField AppletWidthField;
	private JRadioButton ArchiveRadioButton;
	private JPanel panel3;
	private JLabel label3;
	private JTextField ScheduleTitleField;
	private JLabel EventLabel;
	private JButton AddEventButton;
	private JButton ModifyEventButton;
	private JButton RemoveEventButton;
	private JScrollPane scrollPane1;
	private JList EventList;
	private JPanel panel4;
	private JLabel label8;
	private JTextField ImageTitleField;
	private JLabel label11;
	private JTextField ImageLocationField;
	private JButton ImageBrowseButton;
	private JLabel label10;
	private JTextField alttextField;
	private JLabel label14;
	private JComboBox ImageAlignComboBox;
	private JLabel label12;
	private JTextField ImageHeightField;
	private JLabel label13;
	private JTextField ImageWidthField;
	private JPanel buttonBar;
	private JButton SaveButton;
	private JButton cancelButton;
	// JFormDesigner - End of variables declaration  //GEN-END:variables
}
